/*! For license information please see index.js.LICENSE.txt */
define(["module","@jupyter-widgets/base"],((t,e)=>(()=>{"use strict";var n={930:(t,e,n)=>{n.d(e,{A:()=>a});var i=n(601),r=n.n(i),o=n(314),s=n.n(o)()(r());s.push([t.id,'.graph {\n  border: 1px solid #ccc !important;\n}\n\n/***** EMBEDDING *****/\n.basic .dashboard-div {\n  border: 1px solid black;\n  text-align: center;\n}\n\n.dark .dashboard-div {\n  margin: 2px;\n  border-radius: 10px;\n  background-color: #262626;\n  box-shadow: 0 4px 8px rgba(0, 0, 0, 0.5);\n}\n\n.glassmorphism .dashboard-div {\n  margin: 5px;\n  border-radius: 10px;\n  background: rgb(255, 254, 254);\n  border: 1px solid rgb(255, 255, 255);\n  backdrop-filter: blur(10px);\n  box-shadow: 0 4px 6px rgba(0, 0, 0, 0.1);\n}\n\n.neumorphism .dashboard-div {\n  margin: 10px;\n  border-radius: 15px;\n  background-color: #e0e0e0;\n  box-shadow: 5px 5px 10px #bebebe, -5px -5px 10px #ffffff;\n}\n\n.minimalism .dashboard-div {\n  margin-bottom: 5px;\n}\n\n/***** RANGE SLIDER *****/\n.range_outside_container {\n  display: flex;\n  max-width: 500px;\n}\n\n.range_inside_container {\n  display: flex;\n  flex-direction: column;\n  width: 80%;\n}\n\n.range_description {\n  padding-right: 20px;\n}\n\n.range_value {\n  padding-left: 20px;\n  width: 80px;\n}\n\n.sliders_control {\n  position: relative;\n  min-height: 50px;\n}\n\ninput[type="range"]::-webkit-slider-thumb {\n  -webkit-appearance: none;\n  pointer-events: all;\n  width: 24px;\n  height: 24px;\n  background-color: #fff;\n  border-radius: 50%;\n  box-shadow: 0 0 0 1px #c6c6c6;\n  cursor: pointer;\n}\n\ninput[type="range"]::-moz-range-thumb {\n  -webkit-appearance: none;\n  pointer-events: all;\n  width: 24px;\n  height: 24px;\n  background-color: #fff;\n  border-radius: 50%;\n  box-shadow: 0 0 0 1px #c6c6c6;\n  cursor: pointer;\n}\n\ninput[type="range"]::-webkit-slider-thumb:hover {\n  background: #f7f7f7;\n}\n\ninput[type="range"]::-webkit-slider-thumb:active {\n  box-shadow: inset 0 0 3px #387bbe, 0 0 9px #387bbe;\n  -webkit-box-shadow: inset 0 0 3px #387bbe, 0 0 9px #387bbe;\n}\n\ninput[type="range"] {\n  -webkit-appearance: none;\n  appearance: none;\n  height: 10px;\n  width: 100%;\n  border: none !important;\n  position: absolute;\n  background-color: #f79847;\n  pointer-events: none;\n}\n\n.top_slider {\n  height: 0 !important;\n  z-index: 1;\n  top: 5px;\n}\n\n/***** INFORMATION CARD *****/\n.information_card {\n  background-color: white;\n  box-shadow: rgba(0, 0, 0, 0.1) 0px 4px 6px -1px,\n    rgba(0, 0, 0, 0.06) 0px 2px 4px -1px;\n  border-radius: 8px;\n  position: absolute;\n}\n\n.information_card div {\n  padding: 1rem;\n}\n\n/***** SIDE BAR *****/\n.side_bar {\n  margin-top: 10px;\n  height: 100%;\n  float: right;\n  display: flex;\n  flex-direction: column;\n}\n\n.side_bar button {\n  background-color: lightgrey;\n  border: lightgrey;\n  border-radius: 4px;\n  color: white;\n  margin: 4px 4px 0px 4px;\n  padding: 4px 2px 2px 2px;\n}\n\n.side_bar button:hover {\n  background-color: darkgrey;\n  cursor: pointer;\n}\n\n.side_bar button.is_selected {\n  background-color: darkgrey;\n}\n\n.side_bar button.is_selected.mode_negative {\n  background-color: rgb(255, 119, 119);\n}\n\n.side_bar button svg {\n  width: 16px;\n  height: 16px;\n}\n\n/***** SCATTERPLOT *****/\n.dot.selected {\n  fill: blue !important;\n  r: 6 !important;\n}\n\n/***** LINEARPLOT *****/\n.line-dot.selected {\n  fill: blue !important;\n  r: 6 !important;\n  opacity: 0.5 !important;\n}\n\n/***** SELECTION BUTTONS *****/\n.selection_line {\n  stroke: lightgrey;\n  stroke-dasharray: 2, 2;\n  stroke-width: 1;\n  fill: #f0f0f054;\n}\n\n.negative_selection_line {\n  stroke: rgb(255, 119, 119);\n  stroke-dasharray: 2, 2;\n  stroke-width: 1;\n  fill: #ffafaf54;\n}',""]);const a=s},314:t=>{t.exports=function(t){var e=[];return e.toString=function(){return this.map((function(e){var n="",i=void 0!==e[5];return e[4]&&(n+="@supports (".concat(e[4],") {")),e[2]&&(n+="@media ".concat(e[2]," {")),i&&(n+="@layer".concat(e[5].length>0?" ".concat(e[5]):""," {")),n+=t(e),i&&(n+="}"),e[2]&&(n+="}"),e[4]&&(n+="}"),n})).join("")},e.i=function(t,n,i,r,o){"string"==typeof t&&(t=[[null,t,void 0]]);var s={};if(i)for(var a=0;a<this.length;a++){var l=this[a][0];null!=l&&(s[l]=!0)}for(var u=0;u<t.length;u++){var c=[].concat(t[u]);i&&s[c[0]]||(void 0!==o&&(void 0===c[5]||(c[1]="@layer".concat(c[5].length>0?" ".concat(c[5]):""," {").concat(c[1],"}")),c[5]=o),n&&(c[2]?(c[1]="@media ".concat(c[2]," {").concat(c[1],"}"),c[2]=n):c[2]=n),r&&(c[4]?(c[1]="@supports (".concat(c[4],") {").concat(c[1],"}"),c[4]=r):c[4]="".concat(r)),e.push(c))}},e}},601:t=>{t.exports=function(t){return t[1]}},72:t=>{var e=[];function n(t){for(var n=-1,i=0;i<e.length;i++)if(e[i].identifier===t){n=i;break}return n}function i(t,i){for(var o={},s=[],a=0;a<t.length;a++){var l=t[a],u=i.base?l[0]+i.base:l[0],c=o[u]||0,h="".concat(u," ").concat(c);o[u]=c+1;var d=n(h),f={css:l[1],media:l[2],sourceMap:l[3],supports:l[4],layer:l[5]};if(-1!==d)e[d].references++,e[d].updater(f);else{var p=r(f,i);i.byIndex=a,e.splice(a,0,{identifier:h,updater:p,references:1})}s.push(h)}return s}function r(t,e){var n=e.domAPI(e);return n.update(t),function(e){if(e){if(e.css===t.css&&e.media===t.media&&e.sourceMap===t.sourceMap&&e.supports===t.supports&&e.layer===t.layer)return;n.update(t=e)}else n.remove()}}t.exports=function(t,r){var o=i(t=t||[],r=r||{});return function(t){t=t||[];for(var s=0;s<o.length;s++){var a=n(o[s]);e[a].references--}for(var l=i(t,r),u=0;u<o.length;u++){var c=n(o[u]);0===e[c].references&&(e[c].updater(),e.splice(c,1))}o=l}}},659:t=>{var e={};t.exports=function(t,n){var i=function(t){if(void 0===e[t]){var n=document.querySelector(t);if(window.HTMLIFrameElement&&n instanceof window.HTMLIFrameElement)try{n=n.contentDocument.head}catch(t){n=null}e[t]=n}return e[t]}(t);if(!i)throw new Error("Couldn't find a style target. This probably means that the value for the 'insert' parameter is invalid.");i.appendChild(n)}},540:t=>{t.exports=function(t){var e=document.createElement("style");return t.setAttributes(e,t.attributes),t.insert(e,t.options),e}},56:(t,e,n)=>{t.exports=function(t){var e=n.nc;e&&t.setAttribute("nonce",e)}},825:t=>{t.exports=function(t){if("undefined"==typeof document)return{update:function(){},remove:function(){}};var e=t.insertStyleElement(t);return{update:function(n){!function(t,e,n){var i="";n.supports&&(i+="@supports (".concat(n.supports,") {")),n.media&&(i+="@media ".concat(n.media," {"));var r=void 0!==n.layer;r&&(i+="@layer".concat(n.layer.length>0?" ".concat(n.layer):""," {")),i+=n.css,r&&(i+="}"),n.media&&(i+="}"),n.supports&&(i+="}");var o=n.sourceMap;o&&"undefined"!=typeof btoa&&(i+="\n/*# sourceMappingURL=data:application/json;base64,".concat(btoa(unescape(encodeURIComponent(JSON.stringify(o))))," */")),e.styleTagTransform(i,t,e.options)}(e,t,n)},remove:function(){!function(t){if(null===t.parentNode)return!1;t.parentNode.removeChild(t)}(e)}}}},113:t=>{t.exports=function(t,e){if(e.styleSheet)e.styleSheet.cssText=t;else{for(;e.firstChild;)e.removeChild(e.firstChild);e.appendChild(document.createTextNode(t))}}},55:t=>{t.exports=e},308:e=>{e.exports=t},330:t=>{t.exports=JSON.parse('{"name":"d3vis_ipynb","version":"0.3.4","description":"A Custom Jupyter Widget Library with visualizations created with D3.js.","author":"Daniel Adam Miranda","license":"BSD-3-Clause","main":"lib/index.js","repository":{"type":"git","url":"https://github.com/H-IAAC/d3vis_ipynb.git"},"keywords":["jupyter","widgets","ipython","ipywidgets","jupyterlab-extension"],"files":["lib/**/*.js","dist/*.js","css/*.css"],"scripts":{"clean":"rimraf dist/ && rimraf ../d3vis_ipynb/labextension/ && rimraf ../d3vis_ipynb/nbextension","prepublish":"yarn run clean && yarn run build:prod","build":"webpack --mode=development && yarn run build:labextension:dev","build:prod":"webpack --mode=production && yarn run build:labextension","build:labextension":"jupyter labextension build .","build:labextension:dev":"jupyter labextension build --development True .","watch":"webpack --watch --mode=development","start":"webpack serve --open --config webpack.exports.config.js","test":"echo \\"Error: no test specified\\" && exit 1"},"devDependencies":{"@jupyterlab/builder":"^4.0.6","html-webpack-plugin":"^5.6.0","rimraf":"^2.6.1","webpack":"^5","webpack-dev-server":"^5.0.2"},"dependencies":{"@jupyter-widgets/base":"^1.1 || ^2 || ^3 || ^4 || ^6","d3":"^7.9.0","lucide":"^0.429.0"},"jupyterlab":{"extension":"lib/labplugin","outputDir":"../d3vis_ipynb/labextension","sharedPackages":{"@jupyter-widgets/base":{"bundled":false,"singleton":true}}}}')}},i={};function r(t){var e=i[t];if(void 0!==e)return e.exports;var o=i[t]={id:t,exports:{}};return n[t](o,o.exports,r),o.exports}r.n=t=>{var e=t&&t.__esModule?()=>t.default:()=>t;return r.d(e,{a:e}),e},r.d=(t,e)=>{for(var n in e)r.o(e,n)&&!r.o(t,n)&&Object.defineProperty(t,n,{enumerable:!0,get:e[n]})},r.o=(t,e)=>Object.prototype.hasOwnProperty.call(t,e),r.r=t=>{"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},r.p="",r.nc=void 0;var o={};return(()=>{var t=r(308);const e=new URL(t.uri,document.location);e.pathname=e.pathname.slice(0,e.pathname.lastIndexOf("/")+1),r.p=`${e.origin}${e.pathname}`})(),(()=>{r.r(o),r.d(o,{BarPlotModel:()=>Ao,BarPlotView:()=>ko,ButtonModel:()=>Uo,ButtonView:()=>Fo,DecisionPlotModel:()=>So,DecisionPlotView:()=>Eo,DropdownModel:()=>Wo,DropdownView:()=>Go,HistogramPlotModel:()=>Lo,HistogramPlotView:()=>Io,ImageModel:()=>Bo,ImageView:()=>Oo,InputModel:()=>Ko,InputView:()=>Jo,LinearPlotModel:()=>To,LinearPlotView:()=>No,MatrixLayoutModel:()=>jo,MatrixLayoutView:()=>Do,RangeSliderModel:()=>Qo,RangeSliderView:()=>Zo,RidgelinePlotModel:()=>$o,RidgelinePlotView:()=>Co,ScatterPlotModel:()=>zo,ScatterPlotView:()=>Vo,TextAreaModel:()=>ts,TextAreaView:()=>es,TextModel:()=>ns,TextView:()=>is,VideoModel:()=>Xo,VideoView:()=>Ho,WaterfallPlotModel:()=>Ro,WaterfallPlotView:()=>Po,author:()=>t.author,dependencies:()=>t.dependencies,description:()=>t.description,devDependencies:()=>t.devDependencies,files:()=>t.files,jupyterlab:()=>t.jupyterlab,keywords:()=>t.keywords,license:()=>t.license,main:()=>t.main,name:()=>t.name,repository:()=>t.repository,scripts:()=>t.scripts,version:()=>t.version});var t=r(330),e=r(55),n=r(72),i=r.n(n),s=r(825),a=r.n(s),l=r(659),u=r.n(l),c=r(56),h=r.n(c),d=r(540),f=r.n(d),p=r(113),m=r.n(p),g=r(930),v={};v.styleTagTransform=m(),v.setAttributes=h(),v.insert=u().bind(null,"head"),v.domAPI=a(),v.insertStyleElement=f(),i()(g.A,v),g.A&&g.A.locals&&g.A.locals;const y=r(330),_={top:20,right:20,bottom:30,left:40};class b extends e.DOMWidgetModel{defaults(){return{...super.defaults(),_model_module:b.model_module,_view_module:b.view_module,_model_module_version:b.model_module_version,_view_module_version:b.view_module_version}}static model_module=y.name;static model_module_version=y.version;static view_module=y.name;static view_module_version=y.version}class w extends e.DOMWidgetView{plotAfterInterval(){this.timeout&&clearTimeout(this.timeout),this.timeout=setTimeout((()=>{this.plot()}),100)}getElement(){this.elementId=this.model.get("elementId");let t=this.el;return this.elementId&&(t=document.getElementById(this.elementId)),t}setSizes(){const t=this.model.get("elementId");this.height=400;let e=this.el;t&&(e=document.getElementById(t),this.height=e.clientHeight),this.width=e.clientWidth,this.margin=_}}function x(t,e){let n,i;if(void 0===e)for(const e of t)null!=e&&(void 0===n?e>=e&&(n=i=e):(n>e&&(n=e),i<e&&(i=e)));else{let r=-1;for(let o of t)null!=(o=e(o,++r,t))&&(void 0===n?o>=o&&(n=i=o):(n>o&&(n=o),i<o&&(i=o)))}return[n,i]}var M=Array.prototype,A=M.slice;function k(t,e){return null==t||null==e?NaN:t<e?-1:t>e?1:t>=e?0:NaN}function S(t,e){return null==t||null==e?NaN:e<t?-1:e>t?1:e>=t?0:NaN}function E(t){let e,n,i;function r(t,i,r=0,o=t.length){if(r<o){if(0!==e(i,i))return o;do{const e=r+o>>>1;n(t[e],i)<0?r=e+1:o=e}while(r<o)}return r}return 2!==t.length?(e=k,n=(e,n)=>k(t(e),n),i=(e,n)=>t(e)-n):(e=t===k||t===S?t:L,n=t,i=t),{left:r,center:function(t,e,n=0,o=t.length){const s=r(t,e,n,o-1);return s>n&&i(t[s-1],e)>-i(t[s],e)?s-1:s},right:function(t,i,r=0,o=t.length){if(r<o){if(0!==e(i,i))return o;do{const e=r+o>>>1;n(t[e],i)<=0?r=e+1:o=e}while(r<o)}return r}}}function L(){return 0}M.map;const I=E(k),T=I.right,N=(I.left,E((function(t){return null===t?NaN:+t})).center,T);function $(t){return()=>t}function C(t){return t}const z=Math.sqrt(50),V=Math.sqrt(10),R=Math.sqrt(2);function P(t,e,n){const i=(e-t)/Math.max(0,n),r=Math.floor(Math.log10(i)),o=i/Math.pow(10,r),s=o>=z?10:o>=V?5:o>=R?2:1;let a,l,u;return r<0?(u=Math.pow(10,-r)/s,a=Math.round(t*u),l=Math.round(e*u),a/u<t&&++a,l/u>e&&--l,u=-u):(u=Math.pow(10,r)*s,a=Math.round(t/u),l=Math.round(e/u),a*u<t&&++a,l*u>e&&--l),l<a&&.5<=n&&n<2?P(t,e,2*n):[a,l,u]}function j(t,e,n){if(!((n=+n)>0))return[];if((t=+t)==(e=+e))return[t];const i=e<t,[r,o,s]=i?P(e,t,n):P(t,e,n);if(!(o>=r))return[];const a=o-r+1,l=new Array(a);if(i)if(s<0)for(let t=0;t<a;++t)l[t]=(o-t)/-s;else for(let t=0;t<a;++t)l[t]=(o-t)*s;else if(s<0)for(let t=0;t<a;++t)l[t]=(r+t)/-s;else for(let t=0;t<a;++t)l[t]=(r+t)*s;return l}function D(t,e,n){return P(t=+t,e=+e,n=+n)[2]}function B(t){return Math.max(1,Math.ceil(Math.log(function(t){let e=0;for(let n of t)null!=n&&(n=+n)>=n&&++e;return e}(t))/Math.LN2)+1)}function O(t,e){let n;if(void 0===e)for(const e of t)null!=e&&(n<e||void 0===n&&e>=e)&&(n=e);else{let i=-1;for(let r of t)null!=(r=e(r,++i,t))&&(n<r||void 0===n&&r>=r)&&(n=r)}return n}function X(t,e){let n;if(void 0===e)for(const e of t)null!=e&&(n>e||void 0===n&&e>=e)&&(n=e);else{let i=-1;for(let r of t)null!=(r=e(r,++i,t))&&(n>r||void 0===n&&r>=r)&&(n=r)}return n}function H(t){return t}var q=1,Y=2,U=3,F=4,W=1e-6;function G(t){return"translate("+t+",0)"}function K(t){return"translate(0,"+t+")"}function J(t){return e=>+t(e)}function Q(t,e){return e=Math.max(0,t.bandwidth()-2*e)/2,t.round()&&(e=Math.round(e)),n=>+t(n)+e}function Z(){return!this.__axis}function tt(t,e){var n=[],i=null,r=null,o=6,s=6,a=3,l="undefined"!=typeof window&&window.devicePixelRatio>1?0:.5,u=t===q||t===F?-1:1,c=t===F||t===Y?"x":"y",h=t===q||t===U?G:K;function d(d){var f=null==i?e.ticks?e.ticks.apply(e,n):e.domain():i,p=null==r?e.tickFormat?e.tickFormat.apply(e,n):H:r,m=Math.max(o,0)+a,g=e.range(),v=+g[0]+l,y=+g[g.length-1]+l,_=(e.bandwidth?Q:J)(e.copy(),l),b=d.selection?d.selection():d,w=b.selectAll(".domain").data([null]),x=b.selectAll(".tick").data(f,e).order(),M=x.exit(),A=x.enter().append("g").attr("class","tick"),k=x.select("line"),S=x.select("text");w=w.merge(w.enter().insert("path",".tick").attr("class","domain").attr("stroke","currentColor")),x=x.merge(A),k=k.merge(A.append("line").attr("stroke","currentColor").attr(c+"2",u*o)),S=S.merge(A.append("text").attr("fill","currentColor").attr(c,u*m).attr("dy",t===q?"0em":t===U?"0.71em":"0.32em")),d!==b&&(w=w.transition(d),x=x.transition(d),k=k.transition(d),S=S.transition(d),M=M.transition(d).attr("opacity",W).attr("transform",(function(t){return isFinite(t=_(t))?h(t+l):this.getAttribute("transform")})),A.attr("opacity",W).attr("transform",(function(t){var e=this.parentNode.__axis;return h((e&&isFinite(e=e(t))?e:_(t))+l)}))),M.remove(),w.attr("d",t===F||t===Y?s?"M"+u*s+","+v+"H"+l+"V"+y+"H"+u*s:"M"+l+","+v+"V"+y:s?"M"+v+","+u*s+"V"+l+"H"+y+"V"+u*s:"M"+v+","+l+"H"+y),x.attr("opacity",1).attr("transform",(function(t){return h(_(t)+l)})),k.attr(c+"2",u*o),S.attr(c,u*m).text(p),b.filter(Z).attr("fill","none").attr("font-size",10).attr("font-family","sans-serif").attr("text-anchor",t===Y?"start":t===F?"end":"middle"),b.each((function(){this.__axis=_}))}return d.scale=function(t){return arguments.length?(e=t,d):e},d.ticks=function(){return n=Array.from(arguments),d},d.tickArguments=function(t){return arguments.length?(n=null==t?[]:Array.from(t),d):n.slice()},d.tickValues=function(t){return arguments.length?(i=null==t?null:Array.from(t),d):i&&i.slice()},d.tickFormat=function(t){return arguments.length?(r=t,d):r},d.tickSize=function(t){return arguments.length?(o=s=+t,d):o},d.tickSizeInner=function(t){return arguments.length?(o=+t,d):o},d.tickSizeOuter=function(t){return arguments.length?(s=+t,d):s},d.tickPadding=function(t){return arguments.length?(a=+t,d):a},d.offset=function(t){return arguments.length?(l=+t,d):l},d}function et(t){return tt(U,t)}function nt(t){return tt(F,t)}function it(){}function rt(t){return null==t?it:function(){return this.querySelector(t)}}function ot(t){return null==t?[]:Array.isArray(t)?t:Array.from(t)}function st(){return[]}function at(t){return null==t?st:function(){return this.querySelectorAll(t)}}function lt(t){return function(){return this.matches(t)}}function ut(t){return function(e){return e.matches(t)}}var ct=Array.prototype.find;function ht(){return this.firstElementChild}var dt=Array.prototype.filter;function ft(){return Array.from(this.children)}function pt(t){return new Array(t.length)}function mt(t,e){this.ownerDocument=t.ownerDocument,this.namespaceURI=t.namespaceURI,this._next=null,this._parent=t,this.__data__=e}function gt(t,e,n,i,r,o){for(var s,a=0,l=e.length,u=o.length;a<u;++a)(s=e[a])?(s.__data__=o[a],i[a]=s):n[a]=new mt(t,o[a]);for(;a<l;++a)(s=e[a])&&(r[a]=s)}function vt(t,e,n,i,r,o,s){var a,l,u,c=new Map,h=e.length,d=o.length,f=new Array(h);for(a=0;a<h;++a)(l=e[a])&&(f[a]=u=s.call(l,l.__data__,a,e)+"",c.has(u)?r[a]=l:c.set(u,l));for(a=0;a<d;++a)u=s.call(t,o[a],a,o)+"",(l=c.get(u))?(i[a]=l,l.__data__=o[a],c.delete(u)):n[a]=new mt(t,o[a]);for(a=0;a<h;++a)(l=e[a])&&c.get(f[a])===l&&(r[a]=l)}function yt(t){return t.__data__}function _t(t){return"object"==typeof t&&"length"in t?t:Array.from(t)}function bt(t,e){return t<e?-1:t>e?1:t>=e?0:NaN}mt.prototype={constructor:mt,appendChild:function(t){return this._parent.insertBefore(t,this._next)},insertBefore:function(t,e){return this._parent.insertBefore(t,e)},querySelector:function(t){return this._parent.querySelector(t)},querySelectorAll:function(t){return this._parent.querySelectorAll(t)}};var wt="http://www.w3.org/1999/xhtml";const xt={svg:"http://www.w3.org/2000/svg",xhtml:wt,xlink:"http://www.w3.org/1999/xlink",xml:"http://www.w3.org/XML/1998/namespace",xmlns:"http://www.w3.org/2000/xmlns/"};function Mt(t){var e=t+="",n=e.indexOf(":");return n>=0&&"xmlns"!==(e=t.slice(0,n))&&(t=t.slice(n+1)),xt.hasOwnProperty(e)?{space:xt[e],local:t}:t}function At(t){return function(){this.removeAttribute(t)}}function kt(t){return function(){this.removeAttributeNS(t.space,t.local)}}function St(t,e){return function(){this.setAttribute(t,e)}}function Et(t,e){return function(){this.setAttributeNS(t.space,t.local,e)}}function Lt(t,e){return function(){var n=e.apply(this,arguments);null==n?this.removeAttribute(t):this.setAttribute(t,n)}}function It(t,e){return function(){var n=e.apply(this,arguments);null==n?this.removeAttributeNS(t.space,t.local):this.setAttributeNS(t.space,t.local,n)}}function Tt(t){return t.ownerDocument&&t.ownerDocument.defaultView||t.document&&t||t.defaultView}function Nt(t){return function(){this.style.removeProperty(t)}}function $t(t,e,n){return function(){this.style.setProperty(t,e,n)}}function Ct(t,e,n){return function(){var i=e.apply(this,arguments);null==i?this.style.removeProperty(t):this.style.setProperty(t,i,n)}}function zt(t,e){return t.style.getPropertyValue(e)||Tt(t).getComputedStyle(t,null).getPropertyValue(e)}function Vt(t){return function(){delete this[t]}}function Rt(t,e){return function(){this[t]=e}}function Pt(t,e){return function(){var n=e.apply(this,arguments);null==n?delete this[t]:this[t]=n}}function jt(t){return t.trim().split(/^|\s+/)}function Dt(t){return t.classList||new Bt(t)}function Bt(t){this._node=t,this._names=jt(t.getAttribute("class")||"")}function Ot(t,e){for(var n=Dt(t),i=-1,r=e.length;++i<r;)n.add(e[i])}function Xt(t,e){for(var n=Dt(t),i=-1,r=e.length;++i<r;)n.remove(e[i])}function Ht(t){return function(){Ot(this,t)}}function qt(t){return function(){Xt(this,t)}}function Yt(t,e){return function(){(e.apply(this,arguments)?Ot:Xt)(this,t)}}function Ut(){this.textContent=""}function Ft(t){return function(){this.textContent=t}}function Wt(t){return function(){var e=t.apply(this,arguments);this.textContent=null==e?"":e}}function Gt(){this.innerHTML=""}function Kt(t){return function(){this.innerHTML=t}}function Jt(t){return function(){var e=t.apply(this,arguments);this.innerHTML=null==e?"":e}}function Qt(){this.nextSibling&&this.parentNode.appendChild(this)}function Zt(){this.previousSibling&&this.parentNode.insertBefore(this,this.parentNode.firstChild)}function te(t){return function(){var e=this.ownerDocument,n=this.namespaceURI;return n===wt&&e.documentElement.namespaceURI===wt?e.createElement(t):e.createElementNS(n,t)}}function ee(t){return function(){return this.ownerDocument.createElementNS(t.space,t.local)}}function ne(t){var e=Mt(t);return(e.local?ee:te)(e)}function ie(){return null}function re(){var t=this.parentNode;t&&t.removeChild(this)}function oe(){var t=this.cloneNode(!1),e=this.parentNode;return e?e.insertBefore(t,this.nextSibling):t}function se(){var t=this.cloneNode(!0),e=this.parentNode;return e?e.insertBefore(t,this.nextSibling):t}function ae(t){return function(){var e=this.__on;if(e){for(var n,i=0,r=-1,o=e.length;i<o;++i)n=e[i],t.type&&n.type!==t.type||n.name!==t.name?e[++r]=n:this.removeEventListener(n.type,n.listener,n.options);++r?e.length=r:delete this.__on}}}function le(t,e,n){return function(){var i,r=this.__on,o=function(t){return function(e){t.call(this,e,this.__data__)}}(e);if(r)for(var s=0,a=r.length;s<a;++s)if((i=r[s]).type===t.type&&i.name===t.name)return this.removeEventListener(i.type,i.listener,i.options),this.addEventListener(i.type,i.listener=o,i.options=n),void(i.value=e);this.addEventListener(t.type,o,n),i={type:t.type,name:t.name,value:e,listener:o,options:n},r?r.push(i):this.__on=[i]}}function ue(t,e,n){var i=Tt(t),r=i.CustomEvent;"function"==typeof r?r=new r(e,n):(r=i.document.createEvent("Event"),n?(r.initEvent(e,n.bubbles,n.cancelable),r.detail=n.detail):r.initEvent(e,!1,!1)),t.dispatchEvent(r)}function ce(t,e){return function(){return ue(this,t,e)}}function he(t,e){return function(){return ue(this,t,e.apply(this,arguments))}}Bt.prototype={add:function(t){this._names.indexOf(t)<0&&(this._names.push(t),this._node.setAttribute("class",this._names.join(" ")))},remove:function(t){var e=this._names.indexOf(t);e>=0&&(this._names.splice(e,1),this._node.setAttribute("class",this._names.join(" ")))},contains:function(t){return this._names.indexOf(t)>=0}};var de=[null];function fe(t,e){this._groups=t,this._parents=e}function pe(){return new fe([[document.documentElement]],de)}fe.prototype=pe.prototype={constructor:fe,select:function(t){"function"!=typeof t&&(t=rt(t));for(var e=this._groups,n=e.length,i=new Array(n),r=0;r<n;++r)for(var o,s,a=e[r],l=a.length,u=i[r]=new Array(l),c=0;c<l;++c)(o=a[c])&&(s=t.call(o,o.__data__,c,a))&&("__data__"in o&&(s.__data__=o.__data__),u[c]=s);return new fe(i,this._parents)},selectAll:function(t){t="function"==typeof t?function(t){return function(){return ot(t.apply(this,arguments))}}(t):at(t);for(var e=this._groups,n=e.length,i=[],r=[],o=0;o<n;++o)for(var s,a=e[o],l=a.length,u=0;u<l;++u)(s=a[u])&&(i.push(t.call(s,s.__data__,u,a)),r.push(s));return new fe(i,r)},selectChild:function(t){return this.select(null==t?ht:function(t){return function(){return ct.call(this.children,t)}}("function"==typeof t?t:ut(t)))},selectChildren:function(t){return this.selectAll(null==t?ft:function(t){return function(){return dt.call(this.children,t)}}("function"==typeof t?t:ut(t)))},filter:function(t){"function"!=typeof t&&(t=lt(t));for(var e=this._groups,n=e.length,i=new Array(n),r=0;r<n;++r)for(var o,s=e[r],a=s.length,l=i[r]=[],u=0;u<a;++u)(o=s[u])&&t.call(o,o.__data__,u,s)&&l.push(o);return new fe(i,this._parents)},data:function(t,e){if(!arguments.length)return Array.from(this,yt);var n,i=e?vt:gt,r=this._parents,o=this._groups;"function"!=typeof t&&(n=t,t=function(){return n});for(var s=o.length,a=new Array(s),l=new Array(s),u=new Array(s),c=0;c<s;++c){var h=r[c],d=o[c],f=d.length,p=_t(t.call(h,h&&h.__data__,c,r)),m=p.length,g=l[c]=new Array(m),v=a[c]=new Array(m);i(h,d,g,v,u[c]=new Array(f),p,e);for(var y,_,b=0,w=0;b<m;++b)if(y=g[b]){for(b>=w&&(w=b+1);!(_=v[w])&&++w<m;);y._next=_||null}}return(a=new fe(a,r))._enter=l,a._exit=u,a},enter:function(){return new fe(this._enter||this._groups.map(pt),this._parents)},exit:function(){return new fe(this._exit||this._groups.map(pt),this._parents)},join:function(t,e,n){var i=this.enter(),r=this,o=this.exit();return"function"==typeof t?(i=t(i))&&(i=i.selection()):i=i.append(t+""),null!=e&&(r=e(r))&&(r=r.selection()),null==n?o.remove():n(o),i&&r?i.merge(r).order():r},merge:function(t){for(var e=t.selection?t.selection():t,n=this._groups,i=e._groups,r=n.length,o=i.length,s=Math.min(r,o),a=new Array(r),l=0;l<s;++l)for(var u,c=n[l],h=i[l],d=c.length,f=a[l]=new Array(d),p=0;p<d;++p)(u=c[p]||h[p])&&(f[p]=u);for(;l<r;++l)a[l]=n[l];return new fe(a,this._parents)},selection:function(){return this},order:function(){for(var t=this._groups,e=-1,n=t.length;++e<n;)for(var i,r=t[e],o=r.length-1,s=r[o];--o>=0;)(i=r[o])&&(s&&4^i.compareDocumentPosition(s)&&s.parentNode.insertBefore(i,s),s=i);return this},sort:function(t){function e(e,n){return e&&n?t(e.__data__,n.__data__):!e-!n}t||(t=bt);for(var n=this._groups,i=n.length,r=new Array(i),o=0;o<i;++o){for(var s,a=n[o],l=a.length,u=r[o]=new Array(l),c=0;c<l;++c)(s=a[c])&&(u[c]=s);u.sort(e)}return new fe(r,this._parents).order()},call:function(){var t=arguments[0];return arguments[0]=this,t.apply(null,arguments),this},nodes:function(){return Array.from(this)},node:function(){for(var t=this._groups,e=0,n=t.length;e<n;++e)for(var i=t[e],r=0,o=i.length;r<o;++r){var s=i[r];if(s)return s}return null},size:function(){let t=0;for(const e of this)++t;return t},empty:function(){return!this.node()},each:function(t){for(var e=this._groups,n=0,i=e.length;n<i;++n)for(var r,o=e[n],s=0,a=o.length;s<a;++s)(r=o[s])&&t.call(r,r.__data__,s,o);return this},attr:function(t,e){var n=Mt(t);if(arguments.length<2){var i=this.node();return n.local?i.getAttributeNS(n.space,n.local):i.getAttribute(n)}return this.each((null==e?n.local?kt:At:"function"==typeof e?n.local?It:Lt:n.local?Et:St)(n,e))},style:function(t,e,n){return arguments.length>1?this.each((null==e?Nt:"function"==typeof e?Ct:$t)(t,e,null==n?"":n)):zt(this.node(),t)},property:function(t,e){return arguments.length>1?this.each((null==e?Vt:"function"==typeof e?Pt:Rt)(t,e)):this.node()[t]},classed:function(t,e){var n=jt(t+"");if(arguments.length<2){for(var i=Dt(this.node()),r=-1,o=n.length;++r<o;)if(!i.contains(n[r]))return!1;return!0}return this.each(("function"==typeof e?Yt:e?Ht:qt)(n,e))},text:function(t){return arguments.length?this.each(null==t?Ut:("function"==typeof t?Wt:Ft)(t)):this.node().textContent},html:function(t){return arguments.length?this.each(null==t?Gt:("function"==typeof t?Jt:Kt)(t)):this.node().innerHTML},raise:function(){return this.each(Qt)},lower:function(){return this.each(Zt)},append:function(t){var e="function"==typeof t?t:ne(t);return this.select((function(){return this.appendChild(e.apply(this,arguments))}))},insert:function(t,e){var n="function"==typeof t?t:ne(t),i=null==e?ie:"function"==typeof e?e:rt(e);return this.select((function(){return this.insertBefore(n.apply(this,arguments),i.apply(this,arguments)||null)}))},remove:function(){return this.each(re)},clone:function(t){return this.select(t?se:oe)},datum:function(t){return arguments.length?this.property("__data__",t):this.node().__data__},on:function(t,e,n){var i,r,o=function(t){return t.trim().split(/^|\s+/).map((function(t){var e="",n=t.indexOf(".");return n>=0&&(e=t.slice(n+1),t=t.slice(0,n)),{type:t,name:e}}))}(t+""),s=o.length;if(!(arguments.length<2)){for(a=e?le:ae,i=0;i<s;++i)this.each(a(o[i],e,n));return this}var a=this.node().__on;if(a)for(var l,u=0,c=a.length;u<c;++u)for(i=0,l=a[u];i<s;++i)if((r=o[i]).type===l.type&&r.name===l.name)return l.value},dispatch:function(t,e){return this.each(("function"==typeof e?he:ce)(t,e))},[Symbol.iterator]:function*(){for(var t=this._groups,e=0,n=t.length;e<n;++e)for(var i,r=t[e],o=0,s=r.length;o<s;++o)(i=r[o])&&(yield i)}};const me=pe;var ge={value:()=>{}};function ve(){for(var t,e=0,n=arguments.length,i={};e<n;++e){if(!(t=arguments[e]+"")||t in i||/[\s.]/.test(t))throw new Error("illegal type: "+t);i[t]=[]}return new ye(i)}function ye(t){this._=t}function _e(t,e){for(var n,i=0,r=t.length;i<r;++i)if((n=t[i]).name===e)return n.value}function be(t,e,n){for(var i=0,r=t.length;i<r;++i)if(t[i].name===e){t[i]=ge,t=t.slice(0,i).concat(t.slice(i+1));break}return null!=n&&t.push({name:e,value:n}),t}ye.prototype=ve.prototype={constructor:ye,on:function(t,e){var n,i,r=this._,o=(i=r,(t+"").trim().split(/^|\s+/).map((function(t){var e="",n=t.indexOf(".");if(n>=0&&(e=t.slice(n+1),t=t.slice(0,n)),t&&!i.hasOwnProperty(t))throw new Error("unknown type: "+t);return{type:t,name:e}}))),s=-1,a=o.length;if(!(arguments.length<2)){if(null!=e&&"function"!=typeof e)throw new Error("invalid callback: "+e);for(;++s<a;)if(n=(t=o[s]).type)r[n]=be(r[n],t.name,e);else if(null==e)for(n in r)r[n]=be(r[n],t.name,null);return this}for(;++s<a;)if((n=(t=o[s]).type)&&(n=_e(r[n],t.name)))return n},copy:function(){var t={},e=this._;for(var n in e)t[n]=e[n].slice();return new ye(t)},call:function(t,e){if((n=arguments.length-2)>0)for(var n,i,r=new Array(n),o=0;o<n;++o)r[o]=arguments[o+2];if(!this._.hasOwnProperty(t))throw new Error("unknown type: "+t);for(o=0,n=(i=this._[t]).length;o<n;++o)i[o].value.apply(e,r)},apply:function(t,e,n){if(!this._.hasOwnProperty(t))throw new Error("unknown type: "+t);for(var i=this._[t],r=0,o=i.length;r<o;++r)i[r].value.apply(e,n)}};const we=ve;var xe,Me,Ae=0,ke=0,Se=0,Ee=1e3,Le=0,Ie=0,Te=0,Ne="object"==typeof performance&&performance.now?performance:Date,$e="object"==typeof window&&window.requestAnimationFrame?window.requestAnimationFrame.bind(window):function(t){setTimeout(t,17)};function Ce(){return Ie||($e(ze),Ie=Ne.now()+Te)}function ze(){Ie=0}function Ve(){this._call=this._time=this._next=null}function Re(t,e,n){var i=new Ve;return i.restart(t,e,n),i}function Pe(){Ie=(Le=Ne.now())+Te,Ae=ke=0;try{!function(){Ce(),++Ae;for(var t,e=xe;e;)(t=Ie-e._time)>=0&&e._call.call(void 0,t),e=e._next;--Ae}()}finally{Ae=0,function(){for(var t,e,n=xe,i=1/0;n;)n._call?(i>n._time&&(i=n._time),t=n,n=n._next):(e=n._next,n._next=null,n=t?t._next=e:xe=e);Me=t,De(i)}(),Ie=0}}function je(){var t=Ne.now(),e=t-Le;e>Ee&&(Te-=e,Le=t)}function De(t){Ae||(ke&&(ke=clearTimeout(ke)),t-Ie>24?(t<1/0&&(ke=setTimeout(Pe,t-Ne.now()-Te)),Se&&(Se=clearInterval(Se))):(Se||(Le=Ne.now(),Se=setInterval(je,Ee)),Ae=1,$e(Pe)))}function Be(t,e,n){var i=new Ve;return e=null==e?0:+e,i.restart((n=>{i.stop(),t(n+e)}),e,n),i}Ve.prototype=Re.prototype={constructor:Ve,restart:function(t,e,n){if("function"!=typeof t)throw new TypeError("callback is not a function");n=(null==n?Ce():+n)+(null==e?0:+e),this._next||Me===this||(Me?Me._next=this:xe=this,Me=this),this._call=t,this._time=n,De()},stop:function(){this._call&&(this._call=null,this._time=1/0,De())}};var Oe=we("start","end","cancel","interrupt"),Xe=[],He=0,qe=2,Ye=3,Ue=5,Fe=6;function We(t,e,n,i,r,o){var s=t.__transition;if(s){if(n in s)return}else t.__transition={};!function(t,e,n){var i,r=t.__transition;function o(l){var u,c,h,d;if(1!==n.state)return a();for(u in r)if((d=r[u]).name===n.name){if(d.state===Ye)return Be(o);4===d.state?(d.state=Fe,d.timer.stop(),d.on.call("interrupt",t,t.__data__,d.index,d.group),delete r[u]):+u<e&&(d.state=Fe,d.timer.stop(),d.on.call("cancel",t,t.__data__,d.index,d.group),delete r[u])}if(Be((function(){n.state===Ye&&(n.state=4,n.timer.restart(s,n.delay,n.time),s(l))})),n.state=qe,n.on.call("start",t,t.__data__,n.index,n.group),n.state===qe){for(n.state=Ye,i=new Array(h=n.tween.length),u=0,c=-1;u<h;++u)(d=n.tween[u].value.call(t,t.__data__,n.index,n.group))&&(i[++c]=d);i.length=c+1}}function s(e){for(var r=e<n.duration?n.ease.call(null,e/n.duration):(n.timer.restart(a),n.state=Ue,1),o=-1,s=i.length;++o<s;)i[o].call(t,r);n.state===Ue&&(n.on.call("end",t,t.__data__,n.index,n.group),a())}function a(){for(var i in n.state=Fe,n.timer.stop(),delete r[e],r)return;delete t.__transition}r[e]=n,n.timer=Re((function(t){n.state=1,n.timer.restart(o,n.delay,n.time),n.delay<=t&&o(t-n.delay)}),0,n.time)}(t,n,{name:e,index:i,group:r,on:Oe,tween:Xe,time:o.time,delay:o.delay,duration:o.duration,ease:o.ease,timer:null,state:He})}function Ge(t,e){var n=Je(t,e);if(n.state>He)throw new Error("too late; already scheduled");return n}function Ke(t,e){var n=Je(t,e);if(n.state>Ye)throw new Error("too late; already running");return n}function Je(t,e){var n=t.__transition;if(!n||!(n=n[e]))throw new Error("transition not found");return n}function Qe(t,e){var n,i,r,o=t.__transition,s=!0;if(o){for(r in e=null==e?null:e+"",o)(n=o[r]).name===e?(i=n.state>qe&&n.state<Ue,n.state=Fe,n.timer.stop(),n.on.call(i?"interrupt":"cancel",t,t.__data__,n.index,n.group),delete o[r]):s=!1;s&&delete t.__transition}}function Ze(t,e){return t=+t,e=+e,function(n){return t*(1-n)+e*n}}var tn,en=180/Math.PI,nn={translateX:0,translateY:0,rotate:0,skewX:0,scaleX:1,scaleY:1};function rn(t,e,n,i,r,o){var s,a,l;return(s=Math.sqrt(t*t+e*e))&&(t/=s,e/=s),(l=t*n+e*i)&&(n-=t*l,i-=e*l),(a=Math.sqrt(n*n+i*i))&&(n/=a,i/=a,l/=a),t*i<e*n&&(t=-t,e=-e,l=-l,s=-s),{translateX:r,translateY:o,rotate:Math.atan2(e,t)*en,skewX:Math.atan(l)*en,scaleX:s,scaleY:a}}function on(t,e,n,i){function r(t){return t.length?t.pop()+" ":""}return function(o,s){var a=[],l=[];return o=t(o),s=t(s),function(t,i,r,o,s,a){if(t!==r||i!==o){var l=s.push("translate(",null,e,null,n);a.push({i:l-4,x:Ze(t,r)},{i:l-2,x:Ze(i,o)})}else(r||o)&&s.push("translate("+r+e+o+n)}(o.translateX,o.translateY,s.translateX,s.translateY,a,l),function(t,e,n,o){t!==e?(t-e>180?e+=360:e-t>180&&(t+=360),o.push({i:n.push(r(n)+"rotate(",null,i)-2,x:Ze(t,e)})):e&&n.push(r(n)+"rotate("+e+i)}(o.rotate,s.rotate,a,l),function(t,e,n,o){t!==e?o.push({i:n.push(r(n)+"skewX(",null,i)-2,x:Ze(t,e)}):e&&n.push(r(n)+"skewX("+e+i)}(o.skewX,s.skewX,a,l),function(t,e,n,i,o,s){if(t!==n||e!==i){var a=o.push(r(o)+"scale(",null,",",null,")");s.push({i:a-4,x:Ze(t,n)},{i:a-2,x:Ze(e,i)})}else 1===n&&1===i||o.push(r(o)+"scale("+n+","+i+")")}(o.scaleX,o.scaleY,s.scaleX,s.scaleY,a,l),o=s=null,function(t){for(var e,n=-1,i=l.length;++n<i;)a[(e=l[n]).i]=e.x(t);return a.join("")}}}var sn=on((function(t){const e=new("function"==typeof DOMMatrix?DOMMatrix:WebKitCSSMatrix)(t+"");return e.isIdentity?nn:rn(e.a,e.b,e.c,e.d,e.e,e.f)}),"px, ","px)","deg)"),an=on((function(t){return null==t?nn:(tn||(tn=document.createElementNS("http://www.w3.org/2000/svg","g")),tn.setAttribute("transform",t),(t=tn.transform.baseVal.consolidate())?rn((t=t.matrix).a,t.b,t.c,t.d,t.e,t.f):nn)}),", ",")",")");function ln(t,e){var n,i;return function(){var r=Ke(this,t),o=r.tween;if(o!==n)for(var s=0,a=(i=n=o).length;s<a;++s)if(i[s].name===e){(i=i.slice()).splice(s,1);break}r.tween=i}}function un(t,e,n){var i,r;if("function"!=typeof n)throw new Error;return function(){var o=Ke(this,t),s=o.tween;if(s!==i){r=(i=s).slice();for(var a={name:e,value:n},l=0,u=r.length;l<u;++l)if(r[l].name===e){r[l]=a;break}l===u&&r.push(a)}o.tween=r}}function cn(t,e,n){var i=t._id;return t.each((function(){var t=Ke(this,i);(t.value||(t.value={}))[e]=n.apply(this,arguments)})),function(t){return Je(t,i).value[e]}}function hn(t,e,n){t.prototype=e.prototype=n,n.constructor=t}function dn(t,e){var n=Object.create(t.prototype);for(var i in e)n[i]=e[i];return n}function fn(){}var pn=.7,mn=1/pn,gn="\\s*([+-]?\\d+)\\s*",vn="\\s*([+-]?(?:\\d*\\.)?\\d+(?:[eE][+-]?\\d+)?)\\s*",yn="\\s*([+-]?(?:\\d*\\.)?\\d+(?:[eE][+-]?\\d+)?)%\\s*",_n=/^#([0-9a-f]{3,8})$/,bn=new RegExp(`^rgb\\(${gn},${gn},${gn}\\)$`),wn=new RegExp(`^rgb\\(${yn},${yn},${yn}\\)$`),xn=new RegExp(`^rgba\\(${gn},${gn},${gn},${vn}\\)$`),Mn=new RegExp(`^rgba\\(${yn},${yn},${yn},${vn}\\)$`),An=new RegExp(`^hsl\\(${vn},${yn},${yn}\\)$`),kn=new RegExp(`^hsla\\(${vn},${yn},${yn},${vn}\\)$`),Sn={aliceblue:15792383,antiquewhite:16444375,aqua:65535,aquamarine:8388564,azure:15794175,beige:16119260,bisque:16770244,black:0,blanchedalmond:16772045,blue:255,blueviolet:9055202,brown:10824234,burlywood:14596231,cadetblue:6266528,chartreuse:8388352,chocolate:13789470,coral:16744272,cornflowerblue:6591981,cornsilk:16775388,crimson:14423100,cyan:65535,darkblue:139,darkcyan:35723,darkgoldenrod:12092939,darkgray:11119017,darkgreen:25600,darkgrey:11119017,darkkhaki:12433259,darkmagenta:9109643,darkolivegreen:5597999,darkorange:16747520,darkorchid:10040012,darkred:9109504,darksalmon:15308410,darkseagreen:9419919,darkslateblue:4734347,darkslategray:3100495,darkslategrey:3100495,darkturquoise:52945,darkviolet:9699539,deeppink:16716947,deepskyblue:49151,dimgray:6908265,dimgrey:6908265,dodgerblue:2003199,firebrick:11674146,floralwhite:16775920,forestgreen:2263842,fuchsia:16711935,gainsboro:14474460,ghostwhite:16316671,gold:16766720,goldenrod:14329120,gray:8421504,green:32768,greenyellow:11403055,grey:8421504,honeydew:15794160,hotpink:16738740,indianred:13458524,indigo:4915330,ivory:16777200,khaki:15787660,lavender:15132410,lavenderblush:16773365,lawngreen:8190976,lemonchiffon:16775885,lightblue:11393254,lightcoral:15761536,lightcyan:14745599,lightgoldenrodyellow:16448210,lightgray:13882323,lightgreen:9498256,lightgrey:13882323,lightpink:16758465,lightsalmon:16752762,lightseagreen:2142890,lightskyblue:8900346,lightslategray:7833753,lightslategrey:7833753,lightsteelblue:11584734,lightyellow:16777184,lime:65280,limegreen:3329330,linen:16445670,magenta:16711935,maroon:8388608,mediumaquamarine:6737322,mediumblue:205,mediumorchid:12211667,mediumpurple:9662683,mediumseagreen:3978097,mediumslateblue:8087790,mediumspringgreen:64154,mediumturquoise:4772300,mediumvioletred:13047173,midnightblue:1644912,mintcream:16121850,mistyrose:16770273,moccasin:16770229,navajowhite:16768685,navy:128,oldlace:16643558,olive:8421376,olivedrab:7048739,orange:16753920,orangered:16729344,orchid:14315734,palegoldenrod:15657130,palegreen:10025880,paleturquoise:11529966,palevioletred:14381203,papayawhip:16773077,peachpuff:16767673,peru:13468991,pink:16761035,plum:14524637,powderblue:11591910,purple:8388736,rebeccapurple:6697881,red:16711680,rosybrown:12357519,royalblue:4286945,saddlebrown:9127187,salmon:16416882,sandybrown:16032864,seagreen:3050327,seashell:16774638,sienna:10506797,silver:12632256,skyblue:8900331,slateblue:6970061,slategray:7372944,slategrey:7372944,snow:16775930,springgreen:65407,steelblue:4620980,tan:13808780,teal:32896,thistle:14204888,tomato:16737095,turquoise:4251856,violet:15631086,wheat:16113331,white:16777215,whitesmoke:16119285,yellow:16776960,yellowgreen:10145074};function En(){return this.rgb().formatHex()}function Ln(){return this.rgb().formatRgb()}function In(t){var e,n;return t=(t+"").trim().toLowerCase(),(e=_n.exec(t))?(n=e[1].length,e=parseInt(e[1],16),6===n?Tn(e):3===n?new Cn(e>>8&15|e>>4&240,e>>4&15|240&e,(15&e)<<4|15&e,1):8===n?Nn(e>>24&255,e>>16&255,e>>8&255,(255&e)/255):4===n?Nn(e>>12&15|e>>8&240,e>>8&15|e>>4&240,e>>4&15|240&e,((15&e)<<4|15&e)/255):null):(e=bn.exec(t))?new Cn(e[1],e[2],e[3],1):(e=wn.exec(t))?new Cn(255*e[1]/100,255*e[2]/100,255*e[3]/100,1):(e=xn.exec(t))?Nn(e[1],e[2],e[3],e[4]):(e=Mn.exec(t))?Nn(255*e[1]/100,255*e[2]/100,255*e[3]/100,e[4]):(e=An.exec(t))?Dn(e[1],e[2]/100,e[3]/100,1):(e=kn.exec(t))?Dn(e[1],e[2]/100,e[3]/100,e[4]):Sn.hasOwnProperty(t)?Tn(Sn[t]):"transparent"===t?new Cn(NaN,NaN,NaN,0):null}function Tn(t){return new Cn(t>>16&255,t>>8&255,255&t,1)}function Nn(t,e,n,i){return i<=0&&(t=e=n=NaN),new Cn(t,e,n,i)}function $n(t,e,n,i){return 1===arguments.length?((r=t)instanceof fn||(r=In(r)),r?new Cn((r=r.rgb()).r,r.g,r.b,r.opacity):new Cn):new Cn(t,e,n,null==i?1:i);var r}function Cn(t,e,n,i){this.r=+t,this.g=+e,this.b=+n,this.opacity=+i}function zn(){return`#${jn(this.r)}${jn(this.g)}${jn(this.b)}`}function Vn(){const t=Rn(this.opacity);return`${1===t?"rgb(":"rgba("}${Pn(this.r)}, ${Pn(this.g)}, ${Pn(this.b)}${1===t?")":`, ${t})`}`}function Rn(t){return isNaN(t)?1:Math.max(0,Math.min(1,t))}function Pn(t){return Math.max(0,Math.min(255,Math.round(t)||0))}function jn(t){return((t=Pn(t))<16?"0":"")+t.toString(16)}function Dn(t,e,n,i){return i<=0?t=e=n=NaN:n<=0||n>=1?t=e=NaN:e<=0&&(t=NaN),new On(t,e,n,i)}function Bn(t){if(t instanceof On)return new On(t.h,t.s,t.l,t.opacity);if(t instanceof fn||(t=In(t)),!t)return new On;if(t instanceof On)return t;var e=(t=t.rgb()).r/255,n=t.g/255,i=t.b/255,r=Math.min(e,n,i),o=Math.max(e,n,i),s=NaN,a=o-r,l=(o+r)/2;return a?(s=e===o?(n-i)/a+6*(n<i):n===o?(i-e)/a+2:(e-n)/a+4,a/=l<.5?o+r:2-o-r,s*=60):a=l>0&&l<1?0:s,new On(s,a,l,t.opacity)}function On(t,e,n,i){this.h=+t,this.s=+e,this.l=+n,this.opacity=+i}function Xn(t){return(t=(t||0)%360)<0?t+360:t}function Hn(t){return Math.max(0,Math.min(1,t||0))}function qn(t,e,n){return 255*(t<60?e+(n-e)*t/60:t<180?n:t<240?e+(n-e)*(240-t)/60:e)}function Yn(t,e,n,i,r){var o=t*t,s=o*t;return((1-3*t+3*o-s)*e+(4-6*o+3*s)*n+(1+3*t+3*o-3*s)*i+s*r)/6}hn(fn,In,{copy(t){return Object.assign(new this.constructor,this,t)},displayable(){return this.rgb().displayable()},hex:En,formatHex:En,formatHex8:function(){return this.rgb().formatHex8()},formatHsl:function(){return Bn(this).formatHsl()},formatRgb:Ln,toString:Ln}),hn(Cn,$n,dn(fn,{brighter(t){return t=null==t?mn:Math.pow(mn,t),new Cn(this.r*t,this.g*t,this.b*t,this.opacity)},darker(t){return t=null==t?pn:Math.pow(pn,t),new Cn(this.r*t,this.g*t,this.b*t,this.opacity)},rgb(){return this},clamp(){return new Cn(Pn(this.r),Pn(this.g),Pn(this.b),Rn(this.opacity))},displayable(){return-.5<=this.r&&this.r<255.5&&-.5<=this.g&&this.g<255.5&&-.5<=this.b&&this.b<255.5&&0<=this.opacity&&this.opacity<=1},hex:zn,formatHex:zn,formatHex8:function(){return`#${jn(this.r)}${jn(this.g)}${jn(this.b)}${jn(255*(isNaN(this.opacity)?1:this.opacity))}`},formatRgb:Vn,toString:Vn})),hn(On,(function(t,e,n,i){return 1===arguments.length?Bn(t):new On(t,e,n,null==i?1:i)}),dn(fn,{brighter(t){return t=null==t?mn:Math.pow(mn,t),new On(this.h,this.s,this.l*t,this.opacity)},darker(t){return t=null==t?pn:Math.pow(pn,t),new On(this.h,this.s,this.l*t,this.opacity)},rgb(){var t=this.h%360+360*(this.h<0),e=isNaN(t)||isNaN(this.s)?0:this.s,n=this.l,i=n+(n<.5?n:1-n)*e,r=2*n-i;return new Cn(qn(t>=240?t-240:t+120,r,i),qn(t,r,i),qn(t<120?t+240:t-120,r,i),this.opacity)},clamp(){return new On(Xn(this.h),Hn(this.s),Hn(this.l),Rn(this.opacity))},displayable(){return(0<=this.s&&this.s<=1||isNaN(this.s))&&0<=this.l&&this.l<=1&&0<=this.opacity&&this.opacity<=1},formatHsl(){const t=Rn(this.opacity);return`${1===t?"hsl(":"hsla("}${Xn(this.h)}, ${100*Hn(this.s)}%, ${100*Hn(this.l)}%${1===t?")":`, ${t})`}`}}));const Un=t=>()=>t;function Fn(t,e){var n=e-t;return n?function(t,e){return function(n){return t+n*e}}(t,n):Un(isNaN(t)?e:t)}const Wn=function t(e){var n=function(t){return 1==(t=+t)?Fn:function(e,n){return n-e?function(t,e,n){return t=Math.pow(t,n),e=Math.pow(e,n)-t,n=1/n,function(i){return Math.pow(t+i*e,n)}}(e,n,t):Un(isNaN(e)?n:e)}}(e);function i(t,e){var i=n((t=$n(t)).r,(e=$n(e)).r),r=n(t.g,e.g),o=n(t.b,e.b),s=Fn(t.opacity,e.opacity);return function(e){return t.r=i(e),t.g=r(e),t.b=o(e),t.opacity=s(e),t+""}}return i.gamma=t,i}(1);function Gn(t){return function(e){var n,i,r=e.length,o=new Array(r),s=new Array(r),a=new Array(r);for(n=0;n<r;++n)i=$n(e[n]),o[n]=i.r||0,s[n]=i.g||0,a[n]=i.b||0;return o=t(o),s=t(s),a=t(a),i.opacity=1,function(t){return i.r=o(t),i.g=s(t),i.b=a(t),i+""}}}Gn((function(t){var e=t.length-1;return function(n){var i=n<=0?n=0:n>=1?(n=1,e-1):Math.floor(n*e),r=t[i],o=t[i+1],s=i>0?t[i-1]:2*r-o,a=i<e-1?t[i+2]:2*o-r;return Yn((n-i/e)*e,s,r,o,a)}})),Gn((function(t){var e=t.length;return function(n){var i=Math.floor(((n%=1)<0?++n:n)*e),r=t[(i+e-1)%e],o=t[i%e],s=t[(i+1)%e],a=t[(i+2)%e];return Yn((n-i/e)*e,r,o,s,a)}}));var Kn=/[-+]?(?:\d+\.?\d*|\.?\d+)(?:[eE][-+]?\d+)?/g,Jn=new RegExp(Kn.source,"g");function Qn(t,e){var n,i,r,o=Kn.lastIndex=Jn.lastIndex=0,s=-1,a=[],l=[];for(t+="",e+="";(n=Kn.exec(t))&&(i=Jn.exec(e));)(r=i.index)>o&&(r=e.slice(o,r),a[s]?a[s]+=r:a[++s]=r),(n=n[0])===(i=i[0])?a[s]?a[s]+=i:a[++s]=i:(a[++s]=null,l.push({i:s,x:Ze(n,i)})),o=Jn.lastIndex;return o<e.length&&(r=e.slice(o),a[s]?a[s]+=r:a[++s]=r),a.length<2?l[0]?function(t){return function(e){return t(e)+""}}(l[0].x):function(t){return function(){return t}}(e):(e=l.length,function(t){for(var n,i=0;i<e;++i)a[(n=l[i]).i]=n.x(t);return a.join("")})}function Zn(t,e){var n;return("number"==typeof e?Ze:e instanceof In?Wn:(n=In(e))?(e=n,Wn):Qn)(t,e)}function ti(t){return function(){this.removeAttribute(t)}}function ei(t){return function(){this.removeAttributeNS(t.space,t.local)}}function ni(t,e,n){var i,r,o=n+"";return function(){var s=this.getAttribute(t);return s===o?null:s===i?r:r=e(i=s,n)}}function ii(t,e,n){var i,r,o=n+"";return function(){var s=this.getAttributeNS(t.space,t.local);return s===o?null:s===i?r:r=e(i=s,n)}}function ri(t,e,n){var i,r,o;return function(){var s,a,l=n(this);if(null!=l)return(s=this.getAttribute(t))===(a=l+"")?null:s===i&&a===r?o:(r=a,o=e(i=s,l));this.removeAttribute(t)}}function oi(t,e,n){var i,r,o;return function(){var s,a,l=n(this);if(null!=l)return(s=this.getAttributeNS(t.space,t.local))===(a=l+"")?null:s===i&&a===r?o:(r=a,o=e(i=s,l));this.removeAttributeNS(t.space,t.local)}}function si(t,e){var n,i;function r(){var r=e.apply(this,arguments);return r!==i&&(n=(i=r)&&function(t,e){return function(n){this.setAttributeNS(t.space,t.local,e.call(this,n))}}(t,r)),n}return r._value=e,r}function ai(t,e){var n,i;function r(){var r=e.apply(this,arguments);return r!==i&&(n=(i=r)&&function(t,e){return function(n){this.setAttribute(t,e.call(this,n))}}(t,r)),n}return r._value=e,r}function li(t,e){return function(){Ge(this,t).delay=+e.apply(this,arguments)}}function ui(t,e){return e=+e,function(){Ge(this,t).delay=e}}function ci(t,e){return function(){Ke(this,t).duration=+e.apply(this,arguments)}}function hi(t,e){return e=+e,function(){Ke(this,t).duration=e}}var di=me.prototype.constructor;function fi(t){return function(){this.style.removeProperty(t)}}var pi=0;function mi(t,e,n,i){this._groups=t,this._parents=e,this._name=n,this._id=i}function gi(){return++pi}var vi=me.prototype;mi.prototype=function(t){return me().transition(t)}.prototype={constructor:mi,select:function(t){var e=this._name,n=this._id;"function"!=typeof t&&(t=rt(t));for(var i=this._groups,r=i.length,o=new Array(r),s=0;s<r;++s)for(var a,l,u=i[s],c=u.length,h=o[s]=new Array(c),d=0;d<c;++d)(a=u[d])&&(l=t.call(a,a.__data__,d,u))&&("__data__"in a&&(l.__data__=a.__data__),h[d]=l,We(h[d],e,n,d,h,Je(a,n)));return new mi(o,this._parents,e,n)},selectAll:function(t){var e=this._name,n=this._id;"function"!=typeof t&&(t=at(t));for(var i=this._groups,r=i.length,o=[],s=[],a=0;a<r;++a)for(var l,u=i[a],c=u.length,h=0;h<c;++h)if(l=u[h]){for(var d,f=t.call(l,l.__data__,h,u),p=Je(l,n),m=0,g=f.length;m<g;++m)(d=f[m])&&We(d,e,n,m,f,p);o.push(f),s.push(l)}return new mi(o,s,e,n)},selectChild:vi.selectChild,selectChildren:vi.selectChildren,filter:function(t){"function"!=typeof t&&(t=lt(t));for(var e=this._groups,n=e.length,i=new Array(n),r=0;r<n;++r)for(var o,s=e[r],a=s.length,l=i[r]=[],u=0;u<a;++u)(o=s[u])&&t.call(o,o.__data__,u,s)&&l.push(o);return new mi(i,this._parents,this._name,this._id)},merge:function(t){if(t._id!==this._id)throw new Error;for(var e=this._groups,n=t._groups,i=e.length,r=n.length,o=Math.min(i,r),s=new Array(i),a=0;a<o;++a)for(var l,u=e[a],c=n[a],h=u.length,d=s[a]=new Array(h),f=0;f<h;++f)(l=u[f]||c[f])&&(d[f]=l);for(;a<i;++a)s[a]=e[a];return new mi(s,this._parents,this._name,this._id)},selection:function(){return new di(this._groups,this._parents)},transition:function(){for(var t=this._name,e=this._id,n=gi(),i=this._groups,r=i.length,o=0;o<r;++o)for(var s,a=i[o],l=a.length,u=0;u<l;++u)if(s=a[u]){var c=Je(s,e);We(s,t,n,u,a,{time:c.time+c.delay+c.duration,delay:0,duration:c.duration,ease:c.ease})}return new mi(i,this._parents,t,n)},call:vi.call,nodes:vi.nodes,node:vi.node,size:vi.size,empty:vi.empty,each:vi.each,on:function(t,e){var n=this._id;return arguments.length<2?Je(this.node(),n).on.on(t):this.each(function(t,e,n){var i,r,o=function(t){return(t+"").trim().split(/^|\s+/).every((function(t){var e=t.indexOf(".");return e>=0&&(t=t.slice(0,e)),!t||"start"===t}))}(e)?Ge:Ke;return function(){var s=o(this,t),a=s.on;a!==i&&(r=(i=a).copy()).on(e,n),s.on=r}}(n,t,e))},attr:function(t,e){var n=Mt(t),i="transform"===n?an:Zn;return this.attrTween(t,"function"==typeof e?(n.local?oi:ri)(n,i,cn(this,"attr."+t,e)):null==e?(n.local?ei:ti)(n):(n.local?ii:ni)(n,i,e))},attrTween:function(t,e){var n="attr."+t;if(arguments.length<2)return(n=this.tween(n))&&n._value;if(null==e)return this.tween(n,null);if("function"!=typeof e)throw new Error;var i=Mt(t);return this.tween(n,(i.local?si:ai)(i,e))},style:function(t,e,n){var i="transform"==(t+="")?sn:Zn;return null==e?this.styleTween(t,function(t,e){var n,i,r;return function(){var o=zt(this,t),s=(this.style.removeProperty(t),zt(this,t));return o===s?null:o===n&&s===i?r:r=e(n=o,i=s)}}(t,i)).on("end.style."+t,fi(t)):"function"==typeof e?this.styleTween(t,function(t,e,n){var i,r,o;return function(){var s=zt(this,t),a=n(this),l=a+"";return null==a&&(this.style.removeProperty(t),l=a=zt(this,t)),s===l?null:s===i&&l===r?o:(r=l,o=e(i=s,a))}}(t,i,cn(this,"style."+t,e))).each(function(t,e){var n,i,r,o,s="style."+e,a="end."+s;return function(){var l=Ke(this,t),u=l.on,c=null==l.value[s]?o||(o=fi(e)):void 0;u===n&&r===c||(i=(n=u).copy()).on(a,r=c),l.on=i}}(this._id,t)):this.styleTween(t,function(t,e,n){var i,r,o=n+"";return function(){var s=zt(this,t);return s===o?null:s===i?r:r=e(i=s,n)}}(t,i,e),n).on("end.style."+t,null)},styleTween:function(t,e,n){var i="style."+(t+="");if(arguments.length<2)return(i=this.tween(i))&&i._value;if(null==e)return this.tween(i,null);if("function"!=typeof e)throw new Error;return this.tween(i,function(t,e,n){var i,r;function o(){var o=e.apply(this,arguments);return o!==r&&(i=(r=o)&&function(t,e,n){return function(i){this.style.setProperty(t,e.call(this,i),n)}}(t,o,n)),i}return o._value=e,o}(t,e,null==n?"":n))},text:function(t){return this.tween("text","function"==typeof t?function(t){return function(){var e=t(this);this.textContent=null==e?"":e}}(cn(this,"text",t)):function(t){return function(){this.textContent=t}}(null==t?"":t+""))},textTween:function(t){var e="text";if(arguments.length<1)return(e=this.tween(e))&&e._value;if(null==t)return this.tween(e,null);if("function"!=typeof t)throw new Error;return this.tween(e,function(t){var e,n;function i(){var i=t.apply(this,arguments);return i!==n&&(e=(n=i)&&function(t){return function(e){this.textContent=t.call(this,e)}}(i)),e}return i._value=t,i}(t))},remove:function(){return this.on("end.remove",function(t){return function(){var e=this.parentNode;for(var n in this.__transition)if(+n!==t)return;e&&e.removeChild(this)}}(this._id))},tween:function(t,e){var n=this._id;if(t+="",arguments.length<2){for(var i,r=Je(this.node(),n).tween,o=0,s=r.length;o<s;++o)if((i=r[o]).name===t)return i.value;return null}return this.each((null==e?ln:un)(n,t,e))},delay:function(t){var e=this._id;return arguments.length?this.each(("function"==typeof t?li:ui)(e,t)):Je(this.node(),e).delay},duration:function(t){var e=this._id;return arguments.length?this.each(("function"==typeof t?ci:hi)(e,t)):Je(this.node(),e).duration},ease:function(t){var e=this._id;return arguments.length?this.each(function(t,e){if("function"!=typeof e)throw new Error;return function(){Ke(this,t).ease=e}}(e,t)):Je(this.node(),e).ease},easeVarying:function(t){if("function"!=typeof t)throw new Error;return this.each(function(t,e){return function(){var n=e.apply(this,arguments);if("function"!=typeof n)throw new Error;Ke(this,t).ease=n}}(this._id,t))},end:function(){var t,e,n=this,i=n._id,r=n.size();return new Promise((function(o,s){var a={value:s},l={value:function(){0==--r&&o()}};n.each((function(){var n=Ke(this,i),r=n.on;r!==t&&((e=(t=r).copy())._.cancel.push(a),e._.interrupt.push(a),e._.end.push(l)),n.on=e})),0===r&&o()}))},[Symbol.iterator]:vi[Symbol.iterator]};var yi={time:null,delay:0,duration:250,ease:function(t){return((t*=2)<=1?t*t*t:(t-=2)*t*t+2)/2}};function _i(t,e){for(var n;!(n=t.__transition)||!(n=n[e]);)if(!(t=t.parentNode))throw new Error(`transition ${e} not found`);return n}me.prototype.interrupt=function(t){return this.each((function(){Qe(this,t)}))},me.prototype.transition=function(t){var e,n;t instanceof mi?(e=t._id,t=t._name):(e=gi(),(n=yi).time=Ce(),t=null==t?null:t+"");for(var i=this._groups,r=i.length,o=0;o<r;++o)for(var s,a=i[o],l=a.length,u=0;u<l;++u)(s=a[u])&&We(s,t,e,u,a,n||_i(s,e));return new mi(i,this._parents,t,e)};const{abs:bi,max:wi,min:xi}=Math;function Mi(t){return{type:t}}function Ai(t){return"string"==typeof t?new fe([[document.querySelector(t)]],[document.documentElement]):new fe([[t]],de)}function ki(t,e){if(t=function(t){let e;for(;e=t.sourceEvent;)t=e;return t}(t),void 0===e&&(e=t.currentTarget),e){var n=e.ownerSVGElement||e;if(n.createSVGPoint){var i=n.createSVGPoint();return i.x=t.clientX,i.y=t.clientY,[(i=i.matrixTransform(e.getScreenCTM().inverse())).x,i.y]}if(e.getBoundingClientRect){var r=e.getBoundingClientRect();return[t.clientX-r.left-e.clientLeft,t.clientY-r.top-e.clientTop]}}return[t.pageX,t.pageY]}["w","e"].map(Mi),["n","s"].map(Mi),["n","w","e","s","nw","ne","sw","se"].map(Mi);const Si={passive:!1},Ei={capture:!0,passive:!1};function Li(t){t.stopImmediatePropagation()}function Ii(t){t.preventDefault(),t.stopImmediatePropagation()}function Ti(t){var e=t.document.documentElement,n=Ai(t).on("dragstart.drag",Ii,Ei);"onselectstart"in e?n.on("selectstart.drag",Ii,Ei):(e.__noselect=e.style.MozUserSelect,e.style.MozUserSelect="none")}function Ni(t,e){var n=t.document.documentElement,i=Ai(t).on("dragstart.drag",null);e&&(i.on("click.drag",Ii,Ei),setTimeout((function(){i.on("click.drag",null)}),0)),"onselectstart"in n?i.on("selectstart.drag",null):(n.style.MozUserSelect=n.__noselect,delete n.__noselect)}const $i=t=>()=>t;function Ci(t,{sourceEvent:e,subject:n,target:i,identifier:r,active:o,x:s,y:a,dx:l,dy:u,dispatch:c}){Object.defineProperties(this,{type:{value:t,enumerable:!0,configurable:!0},sourceEvent:{value:e,enumerable:!0,configurable:!0},subject:{value:n,enumerable:!0,configurable:!0},target:{value:i,enumerable:!0,configurable:!0},identifier:{value:r,enumerable:!0,configurable:!0},active:{value:o,enumerable:!0,configurable:!0},x:{value:s,enumerable:!0,configurable:!0},y:{value:a,enumerable:!0,configurable:!0},dx:{value:l,enumerable:!0,configurable:!0},dy:{value:u,enumerable:!0,configurable:!0},_:{value:c}})}function zi(t){return!t.ctrlKey&&!t.button}function Vi(){return this.parentNode}function Ri(t,e){return null==e?{x:t.x,y:t.y}:e}function Pi(){return navigator.maxTouchPoints||"ontouchstart"in this}function ji(){var t,e,n,i,r=zi,o=Vi,s=Ri,a=Pi,l={},u=we("start","drag","end"),c=0,h=0;function d(t){t.on("mousedown.drag",f).filter(a).on("touchstart.drag",g).on("touchmove.drag",v,Si).on("touchend.drag touchcancel.drag",y).style("touch-action","none").style("-webkit-tap-highlight-color","rgba(0,0,0,0)")}function f(s,a){if(!i&&r.call(this,s,a)){var l=_(this,o.call(this,s,a),s,a,"mouse");l&&(Ai(s.view).on("mousemove.drag",p,Ei).on("mouseup.drag",m,Ei),Ti(s.view),Li(s),n=!1,t=s.clientX,e=s.clientY,l("start",s))}}function p(i){if(Ii(i),!n){var r=i.clientX-t,o=i.clientY-e;n=r*r+o*o>h}l.mouse("drag",i)}function m(t){Ai(t.view).on("mousemove.drag mouseup.drag",null),Ni(t.view,n),Ii(t),l.mouse("end",t)}function g(t,e){if(r.call(this,t,e)){var n,i,s=t.changedTouches,a=o.call(this,t,e),l=s.length;for(n=0;n<l;++n)(i=_(this,a,t,e,s[n].identifier,s[n]))&&(Li(t),i("start",t,s[n]))}}function v(t){var e,n,i=t.changedTouches,r=i.length;for(e=0;e<r;++e)(n=l[i[e].identifier])&&(Ii(t),n("drag",t,i[e]))}function y(t){var e,n,r=t.changedTouches,o=r.length;for(i&&clearTimeout(i),i=setTimeout((function(){i=null}),500),e=0;e<o;++e)(n=l[r[e].identifier])&&(Li(t),n("end",t,r[e]))}function _(t,e,n,i,r,o){var a,h,f,p=u.copy(),m=ki(o||n,e);if(null!=(f=s.call(t,new Ci("beforestart",{sourceEvent:n,target:d,identifier:r,active:c,x:m[0],y:m[1],dx:0,dy:0,dispatch:p}),i)))return a=f.x-m[0]||0,h=f.y-m[1]||0,function n(o,s,u){var g,v=m;switch(o){case"start":l[r]=n,g=c++;break;case"end":delete l[r],--c;case"drag":m=ki(u||s,e),g=c}p.call(o,t,new Ci(o,{sourceEvent:s,subject:f,target:d,identifier:r,active:g,x:m[0]+a,y:m[1]+h,dx:m[0]-v[0],dy:m[1]-v[1],dispatch:p}),i)}}return d.filter=function(t){return arguments.length?(r="function"==typeof t?t:$i(!!t),d):r},d.container=function(t){return arguments.length?(o="function"==typeof t?t:$i(t),d):o},d.subject=function(t){return arguments.length?(s="function"==typeof t?t:$i(t),d):s},d.touchable=function(t){return arguments.length?(a="function"==typeof t?t:$i(!!t),d):a},d.on=function(){var t=u.on.apply(u,arguments);return t===u?d:t},d.clickDistance=function(t){return arguments.length?(h=(t=+t)*t,d):Math.sqrt(h)},d}function Di(t,e){switch(arguments.length){case 0:break;case 1:this.range(t);break;default:this.range(e).domain(t)}return this}Ci.prototype.on=function(){var t=this._.on.apply(this._,arguments);return t===this._?this:t};class Bi extends Map{constructor(t,e=Xi){if(super(),Object.defineProperties(this,{_intern:{value:new Map},_key:{value:e}}),null!=t)for(const[e,n]of t)this.set(e,n)}get(t){return super.get(Oi(this,t))}has(t){return super.has(Oi(this,t))}set(t,e){return super.set(function({_intern:t,_key:e},n){const i=e(n);return t.has(i)?t.get(i):(t.set(i,n),n)}(this,t),e)}delete(t){return super.delete(function({_intern:t,_key:e},n){const i=e(n);return t.has(i)&&(n=t.get(i),t.delete(i)),n}(this,t))}}function Oi({_intern:t,_key:e},n){const i=e(n);return t.has(i)?t.get(i):n}function Xi(t){return null!==t&&"object"==typeof t?t.valueOf():t}Set;const Hi=Symbol("implicit");function qi(){var t=new Bi,e=[],n=[],i=Hi;function r(r){let o=t.get(r);if(void 0===o){if(i!==Hi)return i;t.set(r,o=e.push(r)-1)}return n[o%n.length]}return r.domain=function(n){if(!arguments.length)return e.slice();e=[],t=new Bi;for(const i of n)t.has(i)||t.set(i,e.push(i)-1);return r},r.range=function(t){return arguments.length?(n=Array.from(t),r):n.slice()},r.unknown=function(t){return arguments.length?(i=t,r):i},r.copy=function(){return qi(e,n).unknown(i)},Di.apply(r,arguments),r}function Yi(){var t,e,n=qi().unknown(void 0),i=n.domain,r=n.range,o=0,s=1,a=!1,l=0,u=0,c=.5;function h(){var n=i().length,h=s<o,d=h?s:o,f=h?o:s;t=(f-d)/Math.max(1,n-l+2*u),a&&(t=Math.floor(t)),d+=(f-d-t*(n-l))*c,e=t*(1-l),a&&(d=Math.round(d),e=Math.round(e));var p=function(t,e,n){t=+t,e=+e,n=(r=arguments.length)<2?(e=t,t=0,1):r<3?1:+n;for(var i=-1,r=0|Math.max(0,Math.ceil((e-t)/n)),o=new Array(r);++i<r;)o[i]=t+i*n;return o}(n).map((function(e){return d+t*e}));return r(h?p.reverse():p)}return delete n.unknown,n.domain=function(t){return arguments.length?(i(t),h()):i()},n.range=function(t){return arguments.length?([o,s]=t,o=+o,s=+s,h()):[o,s]},n.rangeRound=function(t){return[o,s]=t,o=+o,s=+s,a=!0,h()},n.bandwidth=function(){return e},n.step=function(){return t},n.round=function(t){return arguments.length?(a=!!t,h()):a},n.padding=function(t){return arguments.length?(l=Math.min(1,u=+t),h()):l},n.paddingInner=function(t){return arguments.length?(l=Math.min(1,t),h()):l},n.paddingOuter=function(t){return arguments.length?(u=+t,h()):u},n.align=function(t){return arguments.length?(c=Math.max(0,Math.min(1,t)),h()):c},n.copy=function(){return Yi(i(),[o,s]).round(a).paddingInner(l).paddingOuter(u).align(c)},Di.apply(h(),arguments)}function Ui(t,e){var n,i=e?e.length:0,r=t?Math.min(i,t.length):0,o=new Array(r),s=new Array(i);for(n=0;n<r;++n)o[n]=Ki(t[n],e[n]);for(;n<i;++n)s[n]=e[n];return function(t){for(n=0;n<r;++n)s[n]=o[n](t);return s}}function Fi(t,e){var n=new Date;return t=+t,e=+e,function(i){return n.setTime(t*(1-i)+e*i),n}}function Wi(t,e){var n,i={},r={};for(n in null!==t&&"object"==typeof t||(t={}),null!==e&&"object"==typeof e||(e={}),e)n in t?i[n]=Ki(t[n],e[n]):r[n]=e[n];return function(t){for(n in i)r[n]=i[n](t);return r}}function Gi(t,e){e||(e=[]);var n,i=t?Math.min(e.length,t.length):0,r=e.slice();return function(o){for(n=0;n<i;++n)r[n]=t[n]*(1-o)+e[n]*o;return r}}function Ki(t,e){var n,i,r=typeof e;return null==e||"boolean"===r?Un(e):("number"===r?Ze:"string"===r?(n=In(e))?(e=n,Wn):Qn:e instanceof In?Wn:e instanceof Date?Fi:(i=e,!ArrayBuffer.isView(i)||i instanceof DataView?Array.isArray(e)?Ui:"function"!=typeof e.valueOf&&"function"!=typeof e.toString||isNaN(e)?Wi:Ze:Gi))(t,e)}function Ji(t,e){return t=+t,e=+e,function(n){return Math.round(t*(1-n)+e*n)}}function Qi(t){return+t}var Zi=[0,1];function tr(t){return t}function er(t,e){return(e-=t=+t)?function(n){return(n-t)/e}:(n=isNaN(e)?NaN:.5,function(){return n});var n}function nr(t,e,n){var i=t[0],r=t[1],o=e[0],s=e[1];return r<i?(i=er(r,i),o=n(s,o)):(i=er(i,r),o=n(o,s)),function(t){return o(i(t))}}function ir(t,e,n){var i=Math.min(t.length,e.length)-1,r=new Array(i),o=new Array(i),s=-1;for(t[i]<t[0]&&(t=t.slice().reverse(),e=e.slice().reverse());++s<i;)r[s]=er(t[s],t[s+1]),o[s]=n(e[s],e[s+1]);return function(e){var n=N(t,e,1,i)-1;return o[n](r[n](e))}}var rr,or=/^(?:(.)?([<>=^]))?([+\-( ])?([$#])?(0)?(\d+)?(,)?(\.\d+)?(~)?([a-z%])?$/i;function sr(t){if(!(e=or.exec(t)))throw new Error("invalid format: "+t);var e;return new ar({fill:e[1],align:e[2],sign:e[3],symbol:e[4],zero:e[5],width:e[6],comma:e[7],precision:e[8]&&e[8].slice(1),trim:e[9],type:e[10]})}function ar(t){this.fill=void 0===t.fill?" ":t.fill+"",this.align=void 0===t.align?">":t.align+"",this.sign=void 0===t.sign?"-":t.sign+"",this.symbol=void 0===t.symbol?"":t.symbol+"",this.zero=!!t.zero,this.width=void 0===t.width?void 0:+t.width,this.comma=!!t.comma,this.precision=void 0===t.precision?void 0:+t.precision,this.trim=!!t.trim,this.type=void 0===t.type?"":t.type+""}function lr(t,e){if((n=(t=e?t.toExponential(e-1):t.toExponential()).indexOf("e"))<0)return null;var n,i=t.slice(0,n);return[i.length>1?i[0]+i.slice(2):i,+t.slice(n+1)]}function ur(t){return(t=lr(Math.abs(t)))?t[1]:NaN}function cr(t,e){var n=lr(t,e);if(!n)return t+"";var i=n[0],r=n[1];return r<0?"0."+new Array(-r).join("0")+i:i.length>r+1?i.slice(0,r+1)+"."+i.slice(r+1):i+new Array(r-i.length+2).join("0")}sr.prototype=ar.prototype,ar.prototype.toString=function(){return this.fill+this.align+this.sign+this.symbol+(this.zero?"0":"")+(void 0===this.width?"":Math.max(1,0|this.width))+(this.comma?",":"")+(void 0===this.precision?"":"."+Math.max(0,0|this.precision))+(this.trim?"~":"")+this.type};const hr={"%":(t,e)=>(100*t).toFixed(e),b:t=>Math.round(t).toString(2),c:t=>t+"",d:function(t){return Math.abs(t=Math.round(t))>=1e21?t.toLocaleString("en").replace(/,/g,""):t.toString(10)},e:(t,e)=>t.toExponential(e),f:(t,e)=>t.toFixed(e),g:(t,e)=>t.toPrecision(e),o:t=>Math.round(t).toString(8),p:(t,e)=>cr(100*t,e),r:cr,s:function(t,e){var n=lr(t,e);if(!n)return t+"";var i=n[0],r=n[1],o=r-(rr=3*Math.max(-8,Math.min(8,Math.floor(r/3))))+1,s=i.length;return o===s?i:o>s?i+new Array(o-s+1).join("0"):o>0?i.slice(0,o)+"."+i.slice(o):"0."+new Array(1-o).join("0")+lr(t,Math.max(0,e+o-1))[0]},X:t=>Math.round(t).toString(16).toUpperCase(),x:t=>Math.round(t).toString(16)};function dr(t){return t}var fr,pr,mr,gr=Array.prototype.map,vr=["y","z","a","f","p","n","µ","m","","k","M","G","T","P","E","Z","Y"];function yr(){var t=function(){var t,e,n,i,r,o,s=Zi,a=Zi,l=Ki,u=tr;function c(){var t,e,n,l=Math.min(s.length,a.length);return u!==tr&&(t=s[0],e=s[l-1],t>e&&(n=t,t=e,e=n),u=function(n){return Math.max(t,Math.min(e,n))}),i=l>2?ir:nr,r=o=null,h}function h(e){return null==e||isNaN(e=+e)?n:(r||(r=i(s.map(t),a,l)))(t(u(e)))}return h.invert=function(n){return u(e((o||(o=i(a,s.map(t),Ze)))(n)))},h.domain=function(t){return arguments.length?(s=Array.from(t,Qi),c()):s.slice()},h.range=function(t){return arguments.length?(a=Array.from(t),c()):a.slice()},h.rangeRound=function(t){return a=Array.from(t),l=Ji,c()},h.clamp=function(t){return arguments.length?(u=!!t||tr,c()):u!==tr},h.interpolate=function(t){return arguments.length?(l=t,c()):l},h.unknown=function(t){return arguments.length?(n=t,h):n},function(n,i){return t=n,e=i,c()}}()(tr,tr);return t.copy=function(){return e=t,yr().domain(e.domain()).range(e.range()).interpolate(e.interpolate()).clamp(e.clamp()).unknown(e.unknown());var e},Di.apply(t,arguments),function(t){var e=t.domain;return t.ticks=function(t){var n=e();return j(n[0],n[n.length-1],null==t?10:t)},t.tickFormat=function(t,n){var i=e();return function(t,e,n,i){var r,o=function(t,e,n){n=+n;const i=(e=+e)<(t=+t),r=i?D(e,t,n):D(t,e,n);return(i?-1:1)*(r<0?1/-r:r)}(t,e,n);switch((i=sr(null==i?",f":i)).type){case"s":var s=Math.max(Math.abs(t),Math.abs(e));return null!=i.precision||isNaN(r=function(t,e){return Math.max(0,3*Math.max(-8,Math.min(8,Math.floor(ur(e)/3)))-ur(Math.abs(t)))}(o,s))||(i.precision=r),mr(i,s);case"":case"e":case"g":case"p":case"r":null!=i.precision||isNaN(r=function(t,e){return t=Math.abs(t),e=Math.abs(e)-t,Math.max(0,ur(e)-ur(t))+1}(o,Math.max(Math.abs(t),Math.abs(e))))||(i.precision=r-("e"===i.type));break;case"f":case"%":null!=i.precision||isNaN(r=function(t){return Math.max(0,-ur(Math.abs(t)))}(o))||(i.precision=r-2*("%"===i.type))}return pr(i)}(i[0],i[i.length-1],null==t?10:t,n)},t.nice=function(n){null==n&&(n=10);var i,r,o=e(),s=0,a=o.length-1,l=o[s],u=o[a],c=10;for(u<l&&(r=l,l=u,u=r,r=s,s=a,a=r);c-- >0;){if((r=D(l,u,n))===i)return o[s]=l,o[a]=u,e(o);if(r>0)l=Math.floor(l/r)*r,u=Math.ceil(u/r)*r;else{if(!(r<0))break;l=Math.ceil(l*r)/r,u=Math.floor(u*r)/r}i=r}return t},t}(t)}fr=function(t){var e,n,i=void 0===t.grouping||void 0===t.thousands?dr:(e=gr.call(t.grouping,Number),n=t.thousands+"",function(t,i){for(var r=t.length,o=[],s=0,a=e[0],l=0;r>0&&a>0&&(l+a+1>i&&(a=Math.max(1,i-l)),o.push(t.substring(r-=a,r+a)),!((l+=a+1)>i));)a=e[s=(s+1)%e.length];return o.reverse().join(n)}),r=void 0===t.currency?"":t.currency[0]+"",o=void 0===t.currency?"":t.currency[1]+"",s=void 0===t.decimal?".":t.decimal+"",a=void 0===t.numerals?dr:function(t){return function(e){return e.replace(/[0-9]/g,(function(e){return t[+e]}))}}(gr.call(t.numerals,String)),l=void 0===t.percent?"%":t.percent+"",u=void 0===t.minus?"−":t.minus+"",c=void 0===t.nan?"NaN":t.nan+"";function h(t){var e=(t=sr(t)).fill,n=t.align,h=t.sign,d=t.symbol,f=t.zero,p=t.width,m=t.comma,g=t.precision,v=t.trim,y=t.type;"n"===y?(m=!0,y="g"):hr[y]||(void 0===g&&(g=12),v=!0,y="g"),(f||"0"===e&&"="===n)&&(f=!0,e="0",n="=");var _="$"===d?r:"#"===d&&/[boxX]/.test(y)?"0"+y.toLowerCase():"",b="$"===d?o:/[%p]/.test(y)?l:"",w=hr[y],x=/[defgprs%]/.test(y);function M(t){var r,o,l,d=_,M=b;if("c"===y)M=w(t)+M,t="";else{var A=(t=+t)<0||1/t<0;if(t=isNaN(t)?c:w(Math.abs(t),g),v&&(t=function(t){t:for(var e,n=t.length,i=1,r=-1;i<n;++i)switch(t[i]){case".":r=e=i;break;case"0":0===r&&(r=i),e=i;break;default:if(!+t[i])break t;r>0&&(r=0)}return r>0?t.slice(0,r)+t.slice(e+1):t}(t)),A&&0==+t&&"+"!==h&&(A=!1),d=(A?"("===h?h:u:"-"===h||"("===h?"":h)+d,M=("s"===y?vr[8+rr/3]:"")+M+(A&&"("===h?")":""),x)for(r=-1,o=t.length;++r<o;)if(48>(l=t.charCodeAt(r))||l>57){M=(46===l?s+t.slice(r+1):t.slice(r))+M,t=t.slice(0,r);break}}m&&!f&&(t=i(t,1/0));var k=d.length+t.length+M.length,S=k<p?new Array(p-k+1).join(e):"";switch(m&&f&&(t=i(S+t,S.length?p-M.length:1/0),S=""),n){case"<":t=d+t+M+S;break;case"=":t=d+S+t+M;break;case"^":t=S.slice(0,k=S.length>>1)+d+t+M+S.slice(k);break;default:t=S+d+t+M}return a(t)}return g=void 0===g?6:/[gprs]/.test(y)?Math.max(1,Math.min(21,g)):Math.max(0,Math.min(20,g)),M.toString=function(){return t+""},M}return{format:h,formatPrefix:function(t,e){var n=h(((t=sr(t)).type="f",t)),i=3*Math.max(-8,Math.min(8,Math.floor(ur(e)/3))),r=Math.pow(10,-i),o=vr[8+i/3];return function(t){return n(r*t)+o}}}}({thousands:",",grouping:[3],currency:["$",""]}),pr=fr.format,mr=fr.formatPrefix;const _r=function(t){for(var e=new Array(10),n=0;n<10;)e[n]="#"+t.slice(6*n,6*++n);return e}("1f77b4ff7f0e2ca02cd627289467bd8c564be377c27f7f7fbcbd2217becf");function br(t){return"string"==typeof t?new fe([document.querySelectorAll(t)],[document.documentElement]):new fe([ot(t)],de)}function wr(t){return function(){return t}}function xr(t){this._context=t}function Mr(t){return new xr(t)}Array.prototype.slice,xr.prototype={areaStart:function(){this._line=0},areaEnd:function(){this._line=NaN},lineStart:function(){this._point=0},lineEnd:function(){(this._line||0!==this._line&&1===this._point)&&this._context.closePath(),this._line=1-this._line},point:function(t,e){switch(t=+t,e=+e,this._point){case 0:this._point=1,this._line?this._context.lineTo(t,e):this._context.moveTo(t,e);break;case 1:this._point=2;default:this._context.lineTo(t,e)}}};const Ar=Math.PI,kr=2*Ar,Sr=1e-6,Er=kr-Sr;function Lr(t){this._+=t[0];for(let e=1,n=t.length;e<n;++e)this._+=arguments[e]+t[e]}class Ir{constructor(t){this._x0=this._y0=this._x1=this._y1=null,this._="",this._append=null==t?Lr:function(t){let e=Math.floor(t);if(!(e>=0))throw new Error(`invalid digits: ${t}`);if(e>15)return Lr;const n=10**e;return function(t){this._+=t[0];for(let e=1,i=t.length;e<i;++e)this._+=Math.round(arguments[e]*n)/n+t[e]}}(t)}moveTo(t,e){this._append`M${this._x0=this._x1=+t},${this._y0=this._y1=+e}`}closePath(){null!==this._x1&&(this._x1=this._x0,this._y1=this._y0,this._append`Z`)}lineTo(t,e){this._append`L${this._x1=+t},${this._y1=+e}`}quadraticCurveTo(t,e,n,i){this._append`Q${+t},${+e},${this._x1=+n},${this._y1=+i}`}bezierCurveTo(t,e,n,i,r,o){this._append`C${+t},${+e},${+n},${+i},${this._x1=+r},${this._y1=+o}`}arcTo(t,e,n,i,r){if(t=+t,e=+e,n=+n,i=+i,(r=+r)<0)throw new Error(`negative radius: ${r}`);let o=this._x1,s=this._y1,a=n-t,l=i-e,u=o-t,c=s-e,h=u*u+c*c;if(null===this._x1)this._append`M${this._x1=t},${this._y1=e}`;else if(h>Sr)if(Math.abs(c*a-l*u)>Sr&&r){let d=n-o,f=i-s,p=a*a+l*l,m=d*d+f*f,g=Math.sqrt(p),v=Math.sqrt(h),y=r*Math.tan((Ar-Math.acos((p+h-m)/(2*g*v)))/2),_=y/v,b=y/g;Math.abs(_-1)>Sr&&this._append`L${t+_*u},${e+_*c}`,this._append`A${r},${r},0,0,${+(c*d>u*f)},${this._x1=t+b*a},${this._y1=e+b*l}`}else this._append`L${this._x1=t},${this._y1=e}`}arc(t,e,n,i,r,o){if(t=+t,e=+e,o=!!o,(n=+n)<0)throw new Error(`negative radius: ${n}`);let s=n*Math.cos(i),a=n*Math.sin(i),l=t+s,u=e+a,c=1^o,h=o?i-r:r-i;null===this._x1?this._append`M${l},${u}`:(Math.abs(this._x1-l)>Sr||Math.abs(this._y1-u)>Sr)&&this._append`L${l},${u}`,n&&(h<0&&(h=h%kr+kr),h>Er?this._append`A${n},${n},0,1,${c},${t-s},${e-a}A${n},${n},0,1,${c},${this._x1=l},${this._y1=u}`:h>Sr&&this._append`A${n},${n},0,${+(h>=Ar)},${c},${this._x1=t+n*Math.cos(r)},${this._y1=e+n*Math.sin(r)}`)}rect(t,e,n,i){this._append`M${this._x0=this._x1=+t},${this._y0=this._y1=+e}h${n=+n}v${+i}h${-n}Z`}toString(){return this._}}function Tr(t){return t[0]}function Nr(t){return t[1]}function $r(t,e){var n=wr(!0),i=null,r=Mr,o=null,s=function(t){let e=3;return t.digits=function(n){if(!arguments.length)return e;if(null==n)e=null;else{const t=Math.floor(n);if(!(t>=0))throw new RangeError(`invalid digits: ${n}`);e=t}return t},()=>new Ir(e)}(a);function a(a){var l,u,c,h=(a=function(t){return"object"==typeof t&&"length"in t?t:Array.from(t)}(a)).length,d=!1;for(null==i&&(o=r(c=s())),l=0;l<=h;++l)!(l<h&&n(u=a[l],l,a))===d&&((d=!d)?o.lineStart():o.lineEnd()),d&&o.point(+t(u,l,a),+e(u,l,a));if(c)return o=null,c+""||null}return t="function"==typeof t?t:void 0===t?Tr:wr(t),e="function"==typeof e?e:void 0===e?Nr:wr(e),a.x=function(e){return arguments.length?(t="function"==typeof e?e:wr(+e),a):t},a.y=function(t){return arguments.length?(e="function"==typeof t?t:wr(+t),a):e},a.defined=function(t){return arguments.length?(n="function"==typeof t?t:wr(!!t),a):n},a.curve=function(t){return arguments.length?(r=t,null!=i&&(o=r(i)),a):r},a.context=function(t){return arguments.length?(null==t?i=o=null:o=r(i=t),a):i},a}function Cr(t){return((t=Math.exp(t))+1/t)/2}const zr=function t(e,n,i){function r(t,r){var o,s,a=t[0],l=t[1],u=t[2],c=r[0],h=r[1],d=r[2],f=c-a,p=h-l,m=f*f+p*p;if(m<1e-12)s=Math.log(d/u)/e,o=function(t){return[a+t*f,l+t*p,u*Math.exp(e*t*s)]};else{var g=Math.sqrt(m),v=(d*d-u*u+i*m)/(2*u*n*g),y=(d*d-u*u-i*m)/(2*d*n*g),_=Math.log(Math.sqrt(v*v+1)-v),b=Math.log(Math.sqrt(y*y+1)-y);s=(b-_)/e,o=function(t){var i,r=t*s,o=Cr(_),c=u/(n*g)*(o*(i=e*r+_,((i=Math.exp(2*i))-1)/(i+1))-function(t){return((t=Math.exp(t))-1/t)/2}(_));return[a+c*f,l+c*p,u*o/Cr(e*r+_)]}}return o.duration=1e3*s*e/Math.SQRT2,o}return r.rho=function(e){var n=Math.max(.001,+e),i=n*n;return t(n,i,i*i)},r}(Math.SQRT2,2,4),Vr=t=>()=>t;function Rr(t,{sourceEvent:e,target:n,transform:i,dispatch:r}){Object.defineProperties(this,{type:{value:t,enumerable:!0,configurable:!0},sourceEvent:{value:e,enumerable:!0,configurable:!0},target:{value:n,enumerable:!0,configurable:!0},transform:{value:i,enumerable:!0,configurable:!0},_:{value:r}})}function Pr(t,e,n){this.k=t,this.x=e,this.y=n}Pr.prototype={constructor:Pr,scale:function(t){return 1===t?this:new Pr(this.k*t,this.x,this.y)},translate:function(t,e){return 0===t&0===e?this:new Pr(this.k,this.x+this.k*t,this.y+this.k*e)},apply:function(t){return[t[0]*this.k+this.x,t[1]*this.k+this.y]},applyX:function(t){return t*this.k+this.x},applyY:function(t){return t*this.k+this.y},invert:function(t){return[(t[0]-this.x)/this.k,(t[1]-this.y)/this.k]},invertX:function(t){return(t-this.x)/this.k},invertY:function(t){return(t-this.y)/this.k},rescaleX:function(t){return t.copy().domain(t.range().map(this.invertX,this).map(t.invert,t))},rescaleY:function(t){return t.copy().domain(t.range().map(this.invertY,this).map(t.invert,t))},toString:function(){return"translate("+this.x+","+this.y+") scale("+this.k+")"}};var jr=new Pr(1,0,0);function Dr(t){t.stopImmediatePropagation()}function Br(t){t.preventDefault(),t.stopImmediatePropagation()}function Or(t){return!(t.ctrlKey&&"wheel"!==t.type||t.button)}function Xr(){var t=this;return t instanceof SVGElement?(t=t.ownerSVGElement||t).hasAttribute("viewBox")?[[(t=t.viewBox.baseVal).x,t.y],[t.x+t.width,t.y+t.height]]:[[0,0],[t.width.baseVal.value,t.height.baseVal.value]]:[[0,0],[t.clientWidth,t.clientHeight]]}function Hr(){return this.__zoom||jr}function qr(t){return-t.deltaY*(1===t.deltaMode?.05:t.deltaMode?1:.002)*(t.ctrlKey?10:1)}function Yr(){return navigator.maxTouchPoints||"ontouchstart"in this}function Ur(t,e,n){var i=t.invertX(e[0][0])-n[0][0],r=t.invertX(e[1][0])-n[1][0],o=t.invertY(e[0][1])-n[0][1],s=t.invertY(e[1][1])-n[1][1];return t.translate(r>i?(i+r)/2:Math.min(0,i)||Math.max(0,r),s>o?(o+s)/2:Math.min(0,o)||Math.max(0,s))}function Fr(){var t,e,n,i=Or,r=Xr,o=Ur,s=qr,a=Yr,l=[0,1/0],u=[[-1/0,-1/0],[1/0,1/0]],c=250,h=zr,d=we("start","zoom","end"),f=500,p=150,m=0,g=10;function v(t){t.property("__zoom",Hr).on("wheel.zoom",A,{passive:!1}).on("mousedown.zoom",k).on("dblclick.zoom",S).filter(a).on("touchstart.zoom",E).on("touchmove.zoom",L).on("touchend.zoom touchcancel.zoom",I).style("-webkit-tap-highlight-color","rgba(0,0,0,0)")}function y(t,e){return(e=Math.max(l[0],Math.min(l[1],e)))===t.k?t:new Pr(e,t.x,t.y)}function _(t,e,n){var i=e[0]-n[0]*t.k,r=e[1]-n[1]*t.k;return i===t.x&&r===t.y?t:new Pr(t.k,i,r)}function b(t){return[(+t[0][0]+ +t[1][0])/2,(+t[0][1]+ +t[1][1])/2]}function w(t,e,n,i){t.on("start.zoom",(function(){x(this,arguments).event(i).start()})).on("interrupt.zoom end.zoom",(function(){x(this,arguments).event(i).end()})).tween("zoom",(function(){var t=this,o=arguments,s=x(t,o).event(i),a=r.apply(t,o),l=null==n?b(a):"function"==typeof n?n.apply(t,o):n,u=Math.max(a[1][0]-a[0][0],a[1][1]-a[0][1]),c=t.__zoom,d="function"==typeof e?e.apply(t,o):e,f=h(c.invert(l).concat(u/c.k),d.invert(l).concat(u/d.k));return function(t){if(1===t)t=d;else{var e=f(t),n=u/e[2];t=new Pr(n,l[0]-e[0]*n,l[1]-e[1]*n)}s.zoom(null,t)}}))}function x(t,e,n){return!n&&t.__zooming||new M(t,e)}function M(t,e){this.that=t,this.args=e,this.active=0,this.sourceEvent=null,this.extent=r.apply(t,e),this.taps=0}function A(t,...e){if(i.apply(this,arguments)){var n=x(this,e).event(t),r=this.__zoom,a=Math.max(l[0],Math.min(l[1],r.k*Math.pow(2,s.apply(this,arguments)))),c=ki(t);if(n.wheel)n.mouse[0][0]===c[0]&&n.mouse[0][1]===c[1]||(n.mouse[1]=r.invert(n.mouse[0]=c)),clearTimeout(n.wheel);else{if(r.k===a)return;n.mouse=[c,r.invert(c)],Qe(this),n.start()}Br(t),n.wheel=setTimeout((function(){n.wheel=null,n.end()}),p),n.zoom("mouse",o(_(y(r,a),n.mouse[0],n.mouse[1]),n.extent,u))}}function k(t,...e){if(!n&&i.apply(this,arguments)){var r=t.currentTarget,s=x(this,e,!0).event(t),a=Ai(t.view).on("mousemove.zoom",(function(t){if(Br(t),!s.moved){var e=t.clientX-c,n=t.clientY-h;s.moved=e*e+n*n>m}s.event(t).zoom("mouse",o(_(s.that.__zoom,s.mouse[0]=ki(t,r),s.mouse[1]),s.extent,u))}),!0).on("mouseup.zoom",(function(t){a.on("mousemove.zoom mouseup.zoom",null),Ni(t.view,s.moved),Br(t),s.event(t).end()}),!0),l=ki(t,r),c=t.clientX,h=t.clientY;Ti(t.view),Dr(t),s.mouse=[l,this.__zoom.invert(l)],Qe(this),s.start()}}function S(t,...e){if(i.apply(this,arguments)){var n=this.__zoom,s=ki(t.changedTouches?t.changedTouches[0]:t,this),a=n.invert(s),l=n.k*(t.shiftKey?.5:2),h=o(_(y(n,l),s,a),r.apply(this,e),u);Br(t),c>0?Ai(this).transition().duration(c).call(w,h,s,t):Ai(this).call(v.transform,h,s,t)}}function E(n,...r){if(i.apply(this,arguments)){var o,s,a,l,u=n.touches,c=u.length,h=x(this,r,n.changedTouches.length===c).event(n);for(Dr(n),s=0;s<c;++s)l=[l=ki(a=u[s],this),this.__zoom.invert(l),a.identifier],h.touch0?h.touch1||h.touch0[2]===l[2]||(h.touch1=l,h.taps=0):(h.touch0=l,o=!0,h.taps=1+!!t);t&&(t=clearTimeout(t)),o&&(h.taps<2&&(e=l[0],t=setTimeout((function(){t=null}),f)),Qe(this),h.start())}}function L(t,...e){if(this.__zooming){var n,i,r,s,a=x(this,e).event(t),l=t.changedTouches,c=l.length;for(Br(t),n=0;n<c;++n)r=ki(i=l[n],this),a.touch0&&a.touch0[2]===i.identifier?a.touch0[0]=r:a.touch1&&a.touch1[2]===i.identifier&&(a.touch1[0]=r);if(i=a.that.__zoom,a.touch1){var h=a.touch0[0],d=a.touch0[1],f=a.touch1[0],p=a.touch1[1],m=(m=f[0]-h[0])*m+(m=f[1]-h[1])*m,g=(g=p[0]-d[0])*g+(g=p[1]-d[1])*g;i=y(i,Math.sqrt(m/g)),r=[(h[0]+f[0])/2,(h[1]+f[1])/2],s=[(d[0]+p[0])/2,(d[1]+p[1])/2]}else{if(!a.touch0)return;r=a.touch0[0],s=a.touch0[1]}a.zoom("touch",o(_(i,r,s),a.extent,u))}}function I(t,...i){if(this.__zooming){var r,o,s=x(this,i).event(t),a=t.changedTouches,l=a.length;for(Dr(t),n&&clearTimeout(n),n=setTimeout((function(){n=null}),f),r=0;r<l;++r)o=a[r],s.touch0&&s.touch0[2]===o.identifier?delete s.touch0:s.touch1&&s.touch1[2]===o.identifier&&delete s.touch1;if(s.touch1&&!s.touch0&&(s.touch0=s.touch1,delete s.touch1),s.touch0)s.touch0[1]=this.__zoom.invert(s.touch0[0]);else if(s.end(),2===s.taps&&(o=ki(o,this),Math.hypot(e[0]-o[0],e[1]-o[1])<g)){var u=Ai(this).on("dblclick.zoom");u&&u.apply(this,arguments)}}}return v.transform=function(t,e,n,i){var r=t.selection?t.selection():t;r.property("__zoom",Hr),t!==r?w(t,e,n,i):r.interrupt().each((function(){x(this,arguments).event(i).start().zoom(null,"function"==typeof e?e.apply(this,arguments):e).end()}))},v.scaleBy=function(t,e,n,i){v.scaleTo(t,(function(){return this.__zoom.k*("function"==typeof e?e.apply(this,arguments):e)}),n,i)},v.scaleTo=function(t,e,n,i){v.transform(t,(function(){var t=r.apply(this,arguments),i=this.__zoom,s=null==n?b(t):"function"==typeof n?n.apply(this,arguments):n,a=i.invert(s),l="function"==typeof e?e.apply(this,arguments):e;return o(_(y(i,l),s,a),t,u)}),n,i)},v.translateBy=function(t,e,n,i){v.transform(t,(function(){return o(this.__zoom.translate("function"==typeof e?e.apply(this,arguments):e,"function"==typeof n?n.apply(this,arguments):n),r.apply(this,arguments),u)}),null,i)},v.translateTo=function(t,e,n,i,s){v.transform(t,(function(){var t=r.apply(this,arguments),s=this.__zoom,a=null==i?b(t):"function"==typeof i?i.apply(this,arguments):i;return o(jr.translate(a[0],a[1]).scale(s.k).translate("function"==typeof e?-e.apply(this,arguments):-e,"function"==typeof n?-n.apply(this,arguments):-n),t,u)}),i,s)},M.prototype={event:function(t){return t&&(this.sourceEvent=t),this},start:function(){return 1==++this.active&&(this.that.__zooming=this,this.emit("start")),this},zoom:function(t,e){return this.mouse&&"mouse"!==t&&(this.mouse[1]=e.invert(this.mouse[0])),this.touch0&&"touch"!==t&&(this.touch0[1]=e.invert(this.touch0[0])),this.touch1&&"touch"!==t&&(this.touch1[1]=e.invert(this.touch1[0])),this.that.__zoom=e,this.emit("zoom"),this},end:function(){return 0==--this.active&&(delete this.that.__zooming,this.emit("end")),this},emit:function(t){var e=Ai(this.that).datum();d.call(t,this.that,new Rr(t,{sourceEvent:this.sourceEvent,target:v,type:t,transform:this.that.__zoom,dispatch:d}),e)}},v.wheelDelta=function(t){return arguments.length?(s="function"==typeof t?t:Vr(+t),v):s},v.filter=function(t){return arguments.length?(i="function"==typeof t?t:Vr(!!t),v):i},v.touchable=function(t){return arguments.length?(a="function"==typeof t?t:Vr(!!t),v):a},v.extent=function(t){return arguments.length?(r="function"==typeof t?t:Vr([[+t[0][0],+t[0][1]],[+t[1][0],+t[1][1]]]),v):r},v.scaleExtent=function(t){return arguments.length?(l[0]=+t[0],l[1]=+t[1],v):[l[0],l[1]]},v.translateExtent=function(t){return arguments.length?(u[0][0]=+t[0][0],u[1][0]=+t[1][0],u[0][1]=+t[0][1],u[1][1]=+t[1][1],v):[[u[0][0],u[0][1]],[u[1][0],u[1][1]]]},v.constrain=function(t){return arguments.length?(o=t,v):o},v.duration=function(t){return arguments.length?(c=+t,v):c},v.interpolate=function(t){return arguments.length?(h=t,v):h},v.on=function(){var t=d.on.apply(d,arguments);return t===d?v:t},v.clickDistance=function(t){return arguments.length?(m=(t=+t)*t,v):Math.sqrt(m)},v.tapDistance=function(t){return arguments.length?(g=+t,v):g},v}Pr.prototype;class Wr{element;constructor(t){this.element=t}clear(){Ai(this.element).selectAll("*").remove()}init(t,e,n){this.svg=Ai(this.element).append("svg").attr("width",t-2).attr("height",e).attr("class","graph"),this.gGrid=this.svg.append("g").attr("transform","translate("+n.left+","+n.top+")")}getXLinearScale(t,e,n){const i=e-n.left-n.right,r=yr().range([0,i]);return r.domain(t).nice(),r}getYLinearScale(t,e,n){const i=e-n.top-n.bottom,r=yr().range([i,0]);return r.domain(t).nice(),r}getXBandScale(t,e,n,i){const r=e-n.left-n.right,o=Yi().range([0,r]);return o.domain(t).padding(i),o}getYBandScale(t,e,n,i){const r=e-n.top-n.bottom,o=Yi().range([r,0]);return o.domain(t).padding(i),o}plotAxes(t,e,n,i,r){const o=e.range()[1],s=n.range()[0],a=t.append("g").attr("class","x axis").attr("transform","translate(0,"+s+")").call(et(e));a.append("text").attr("class","label").attr("x",o).attr("y",-6).style("text-anchor","end").attr("fill","black").text(i);const l=t.append("g").attr("class","y axis").call(nt(n));return l.append("text").attr("class","label").attr("transform","rotate(-90)").attr("y",6).attr("dy",".71em").style("text-anchor","end").attr("fill","black").text(r),[a,l]}}function Gr(t){const e=t.reduce(((t,e)=>t+e),0)/t.length,n=1.96*function(t,e){let n=0;return t.forEach((t=>n+=(t-e)**2)),n=Math.sqrt(n)/t.length,n}(t,e);return[e-n,e+n]}class Kr extends Wr{plot(t,e,n,i,r,o,s,a,l){this.init(o,s,a);const u=this.gGrid;let c,h;"vertical"===r?(c=e,h=n):(c=n,h=e),i||(i=c);const d=t.reduce(((t,e)=>(t&&-1===t.indexOf(e[i])&&t.push(e[i]),t)),[]),f={},p=qi(_r);i==c?function(e){let n=t.reduce(((t,e)=>{const n=e[c],i=e[h];if(n in t)t[n]+=i,f[n].qt+=1,f[n][h].push(i);else{const e={qt:1};e[h]=[],e[h].push(i),f[n]=e,t[n]=i}return t}),{});n=Object.keys(n).map((t=>{const e={};return e[c]=t,e[h]=n[t],0!=f[t].qt&&(e[h]=e[h]/f[t].qt),e})),Object.keys(f).forEach((t=>{const e=f[t][h],[n,i]=Gr(e);f[t].min=n,f[t].max=i}));const i=n.map((t=>t[c])).sort(),m=[],g=Object.keys(f).map((t=>f[t]));let v,y,_,b,w,x,M,A;m.push(X(g,(t=>t.min))),m.push(O(g,(t=>t.max))),m[0]>0&&m[1]>0?m[0]=0:m[0]<0&&m[1]<0&&(m[1]=0),"vertical"===r?(v=e.getXBandScale(i,o,a,[.2]),y=e.getYLinearScale(m,s,a),[_,b,w,x,M,A]=[v,y,"x","y","width","height"]):(v=e.getXLinearScale(m,o,a),y=e.getYBandScale(i,s,a,[.2]),[_,b,w,x,M,A]=[y,v,"y","x","height","width"]),l||e.plotAxes(u,v,y,c,h),u.append("g").selectAll("g").data(n).enter().append("rect").attr(w,(function(t){return _(t[c])})).attr(x,(function(t){return b(t[h])<b(0)?b(t[h]):b(0)})).attr(M,_.bandwidth()).attr(A,(function(t){return Math.abs(b(0)-b(t[h]))})).data(d).attr("fill",(function(t){return p(t)}));const k=Object.keys(f).map((t=>{const e={};return e[c]=t,e.min=f[t].min,e.max=f[t].max,e}));u.selectAll().data(k).enter().append("path").attr("fill","none").attr("stroke","black").attr("stroke-width",2).attr("d",(function(t){const e=_(t[c])+_.bandwidth()/2;return"vertical"===r?$r()([[e,b(t.min)],[e,b(t.max)]]):$r()([[b(t.min),e],[b(t.max),e]])}))}(this):function(e){let n=t.reduce(((t,e)=>{const n=e[c],r=e[h],o=e[i];if(n in t){f[n].qt[h+"-"+o]+=1,f[n][o][h].push(r);for(const e of d)o==e&&(t[n][h+"-"+e]+=r)}else{const e={};d.forEach((t=>{e[t]={},e[t][h]=[]}));const i={};for(const t of d)i[h+"-"+t]=0;i[h+"-"+o]=1,e.qt=i,e[o][h].push(r),f[n]=e;const s={};for(const t of d)s[h+"-"+t]=o==t?r:0;t[n]=s}return t}),{});n=Object.keys(n).map((t=>{let e={};e[c]=t;for(const e of Object.keys(n[t]))0!=f[t].qt[e]&&(n[t][e]=n[t][e]/f[t].qt[e]);return e={...e,...n[t]},e})),Object.keys(f).forEach((t=>{d.forEach((e=>{const n=f[t][e][h],[i,r]=Gr(n);f[t][e].min=i,f[t][e].max=r}))}));const m=d.map((t=>h+"-"+t)),g=n.map((t=>t[c])).sort(),v=[];Object.keys(f).map((t=>{d.forEach((e=>v.push(f[t][e])))}));const y=[];let _,b,w,x,M,A,k,S;y.push(X(v,(t=>t.min))),y.push(O(v,(t=>t.max))),y[0]>0&&y[1]>0?y[0]=0:y[0]<0&&y[1]<0&&(y[1]=0),"vertical"===r?(_=e.getXBandScale(g,o,a,[.2]),b=e.getYLinearScale(y,s,a),[w,x,M,A,k,S]=[_,b,"x","y","width","height"]):(_=e.getXLinearScale(y,o,a),b=e.getYBandScale(g,s,a,[.2]),[w,x,M,A,k,S]=[b,_,"y","x","height","width"]),l||e.plotAxes(u,_,b,c,h);const E=Yi().domain(m).range([0,w.bandwidth()]).padding([.05]);u.append("g").selectAll("g").data(n).enter().append("g").attr("transform",(function(t){return"vertical"===r?"translate("+w(t[c])+",0)":"translate(0,"+w(t[c])+")"})).selectAll("rect").data((function(t){return m.map((function(e){return{key:e,value:t[e]}}))})).enter().append("rect").attr(M,(function(t){return E(t.key)})).attr(A,(function(t){return x(t.value)<x(0)?x(t.value):x(0)})).attr(k,E.bandwidth()).attr(S,(function(t){return Math.abs(x(0)-x(t.value))})).data(d).attr("fill",(function(t){return p(t)}));const L=Object.keys(f).map((t=>{let e={};return e[c]=t,e={...e,...f[t]},e}));u.append("g").selectAll("g").data(L).enter().append("g").attr("transform",(function(t){return"vertical"===r?"translate("+w(t[c])+",0)":"translate(0,"+w(t[c])+")"})).selectAll("rect").data((function(t){return d.map((function(e){return{key:h+"-"+e,value:t[e]}}))})).enter().append("path").attr("fill","none").attr("stroke","black").attr("stroke-width",2).attr("d",(function(t){const e=E(t.key)+E.bandwidth()/2;return"vertical"===r?$r()([[e,x(t.value.min)],[e,x(t.value.max)]]):$r()([[x(t.value.min),e],[x(t.value.max),e]])}));const I=u.selectAll(".legend").data(p.domain()).enter().append("g").attr("class","legend").attr("transform",(function(t,e){return"translate(0,"+20*e+")"}));I.append("rect").attr("x",o-a.left-a.right-18).attr("width",18).attr("height",18).style("fill",p),I.append("text").attr("x",o-a.left-a.right-24).attr("y",9).attr("dy",".35em").style("text-anchor","end").text((function(t){return t}))}(this)}replot(t,e,n,i,r,o,s,a){this.clear(),this.plot(t,e,n,i,r,o,s,a)}}const Jr=[{r:17,g:102,b:255},{r:255,g:51,b:51}];class Qr extends Wr{plot(t,e,n,i,r,o,s,a){this.baseValue=i,t.sort(function(t){function e(t){let e=0;return t.forEach((t=>e+=Math.abs(t))),e}let n=1;n=-1;var i=1;return"-"===t[0]&&(i=-1,t=t.substr(1)),function(r,o){return(e(r[t])<e(o[t])?n:e(r[t])>e(o[t])?-1*n:0)*i}}(e)),this.init(r,o,s);const l=this.gGrid,u=function(t,e,n){function i(i){let r=n,o=n,s=n;return t.forEach((t=>{s+=t[e][i],r>s&&(r=s),o<s&&(o=s)})),[r,o]}let r=n,o=n;const s=t[0][e].length;for(let t=0;t<s;t++){const e=i(t);e[0]<r&&(r=e[0]),e[1]>o&&(o=e[1])}o-n>n-r?r=n-o:o=n-r;const a=o-r;return r-=.02*a,o+=.02*a,[r,o]}(t,e,i),c=this.getXLinearScale(u,r,s),h=t.map((function(t){return t[n]})),d=this.getYBandScale(h,o,s,[.2]).paddingOuter(0);a||this.plotAxes(l,c,d,e,n);const f=t[0][e].length;function p(t,r){let o=i,s=[{x:c(o),y:d.range()[0]}];t.forEach((t=>{o+=t[e][r],s.push({x:c(o),y:d(t[n])})}));const a=c(o)/c.range()[1],u=["rgb(",a*Jr[1].r+(1-a)*Jr[0].r,",",a*Jr[1].g+(1-a)*Jr[0].g,",",a*Jr[1].b+(1-a)*Jr[0].b,")"].join("");l.append("path").datum(s).attr("fill","none").attr("stroke",u).attr("stroke-width",2).attr("d",$r().x((t=>t.x)).y((t=>t.y)))}l.selectAll().data(t).enter().append("path").attr("stroke","grey").attr("stroke-dasharray","2,2").attr("d",(function(t){return $r()([[c.range()[0],d(t[n])],[c.range()[1],d(t[n])]])})),l.append("path").attr("fill","none").attr("stroke","grey").attr("stroke-width",2).attr("d",(function(e){return $r()([[c(i),d.range()[0]],[c(i),d(t.at(-1)[n])]])}));for(let e=0;e<f;e++)p(t,e);l.append("defs").append("linearGradient").attr("id","grad").attr("x1","0%").attr("x2","100%").attr("y1","0%").attr("y2","0%").selectAll("stop").data(Jr).enter().append("stop").style("stop-color",(function(t){return["rgb(",t.r,",",t.g,",",t.b,")"].join("")})).attr("offset",(function(t,e){return e/(Jr.length-1)*100+"%"})),l.append("rect").attr("x",c.range()[0]).attr("y",-20).attr("width",c.range()[1]).attr("height",20).style("fill","url(#grad)")}replot(t,e,n,i,r,o,s,a){this.clear(),this.plot(t,e,n,i,r,o,s,a)}}class Zr extends Wr{plot(t,e,n,i,r,o,s,a){const l=function(){var t=C,e=x,n=B;function i(i){Array.isArray(i)||(i=Array.from(i));var r,o,s,a=i.length,l=new Array(a);for(r=0;r<a;++r)l[r]=t(i[r],r,i);var u=e(l),c=u[0],h=u[1],d=n(l,c,h);if(!Array.isArray(d)){const t=h,n=+d;if(e===x&&([c,h]=function(t,e,n){let i;for(;;){const r=D(t,e,n);if(r===i||0===r||!isFinite(r))return[t,e];r>0?(t=Math.floor(t/r)*r,e=Math.ceil(e/r)*r):r<0&&(t=Math.ceil(t*r)/r,e=Math.floor(e*r)/r),i=r}}(c,h,n)),(d=j(c,h,n))[0]<=c&&(s=D(c,h,n)),d[d.length-1]>=h)if(t>=h&&e===x){const t=D(c,h,n);isFinite(t)&&(t>0?h=(Math.floor(h/t)+1)*t:t<0&&(h=(Math.ceil(h*-t)+1)/-t))}else d.pop()}for(var f=d.length,p=0,m=f;d[p]<=c;)++p;for(;d[m-1]>h;)--m;(p||m<f)&&(d=d.slice(p,m),f=m-p);var g,v=new Array(f+1);for(r=0;r<=f;++r)(g=v[r]=[]).x0=r>0?d[r-1]:c,g.x1=r<f?d[r]:h;if(isFinite(s)){if(s>0)for(r=0;r<a;++r)null!=(o=l[r])&&c<=o&&o<=h&&v[Math.min(f,Math.floor((o-c)/s))].push(i[r]);else if(s<0)for(r=0;r<a;++r)if(null!=(o=l[r])&&c<=o&&o<=h){const t=Math.floor((c-o)*s);v[Math.min(f,t+(d[t]<=o))].push(i[r])}}else for(r=0;r<a;++r)null!=(o=l[r])&&c<=o&&o<=h&&v[N(d,o,0,f)].push(i[r]);return v}return i.value=function(e){return arguments.length?(t="function"==typeof e?e:$(e),i):t},i.domain=function(t){return arguments.length?(e="function"==typeof t?t:$([t[0],t[1]]),i):e},i.thresholds=function(t){return arguments.length?(n="function"==typeof t?t:$(Array.isArray(t)?A.call(t):t),i):n},i}().thresholds(40).value((t=>Math.round(10*t[e])/10))(t);let u,c;if(s?u=s:(this.init(n,i,r),u=this.gGrid),a)c=a;else{const i=x(t,(function(t){return t[e]}));c=this.getXLinearScale(i,n,r)}const h=[0,O(l,(t=>t.length))],d=this.getYLinearScale(h,i,r);u.append("g").attr("fill","steelblue").selectAll().data(l).join("rect").attr("x",(t=>c(t.x0)+1)).attr("width",(t=>c(t.x1)-c(t.x0)-1)).attr("y",(t=>d(t.length))).attr("height",(t=>d(0)-d(t.length))),o||this.plotAxes(u,c,d,e)}replot(t,e,n,i,r,o,s,a){this.clear(),this.plot(t,e,n,i,r,o,s,a)}}const to={xmlns:"http://www.w3.org/2000/svg",width:24,height:24,viewBox:"0 0 24 24",fill:"none",stroke:"currentColor","stroke-width":2,"stroke-linecap":"round","stroke-linejoin":"round"},eo=["svg",to,[["path",{d:"M5 3a2 2 0 0 0-2 2"}],["path",{d:"M19 3a2 2 0 0 1 2 2"}],["path",{d:"M21 19a2 2 0 0 1-2 2"}],["path",{d:"M5 21a2 2 0 0 1-2-2"}],["path",{d:"M9 3h1"}],["path",{d:"M9 21h1"}],["path",{d:"M14 3h1"}],["path",{d:"M14 21h1"}],["path",{d:"M3 9v1"}],["path",{d:"M21 9v1"}],["path",{d:"M3 14v1"}],["path",{d:"M21 14v1"}]]],no=(t,e,n=[])=>{const i=document.createElementNS("http://www.w3.org/2000/svg",t);return Object.keys(e).forEach((t=>{i.setAttribute(t,String(e[t]))})),n.length&&n.forEach((t=>{const e=no(...t);i.appendChild(e)})),i};class io{addWhenSelectedCallback(t){this.whenSelectedCallback=t}addWhenUnselectedCallback(t){this.whenUnselectedCallback=t}constructor(t=!1){this.isSelected=t}addClickNotification(t){this.clickNotify=t}notified(){this.unselect()}select(){this.isSelected=!0,this.button.classList.add("is_selected"),this.whenSelectedCallback&&this.whenSelectedCallback()}unselect(){this.isSelected=!1,this.button.classList.remove("is_selected"),this.whenUnselectedCallback&&this.whenUnselectedCallback()}createButton(t){this.button=document.createElement("button"),this.isSelected&&this.button.classList.add("is_selected"),this.button.addEventListener("click",this.on_click.bind(this));const e=(([t,e,n])=>no(t,e,n))(t);return this.button.appendChild(e),this.button}on_click(){this.isSelected||(this.clickNotify(this),this.select())}}function ro(t,e){for(var n=t[0],i=t[1],r=!1,o=0,s=e.length-1;o<e.length;s=o++){var a=e[o][0],l=e[o][1],u=e[s][0],c=e[s][1];l>i!=c>i&&n<(u-a)*(i-l)/(c-l)+a&&(r=!r)}return r}class oo extends io{coords=[];randomString=Math.floor(Math.random()*Date.now()*1e4).toString(36);constructor(t,e,n,i,r,o,s,a,l,u){super(u),this.xScale=t,this.yScale=e,this.x_value=n,this.y_value=i,this.x_translate=r,this.y_translate=o,this.selectables=s,this.callUpdateSelected=a,this.interationRect=l,l.call(this.drag)}createButton(){return super.createButton(eo)}updateScales(t,e){this.xScale=t,this.yScale=e}select(){super.select(),this.mode=!0,this.button.classList.add("mode_positive"),this.button.classList.remove("mode_negative"),this.interationRect.call(this.drag)}unselect(){super.unselect(),this.interationRect.on(".drag",null)}on_click(){this.isSelected&&this.changeMode(),super.on_click()}changeMode(){this.mode=!this.mode,this.mode?(this.button.classList.add("mode_positive"),this.button.classList.remove("mode_negative")):(this.button.classList.add("mode_negative"),this.button.classList.remove("mode_positive"))}drawPath(){Ai("#lasso"+this.randomString).classed("selection_line",this.mode).classed("negative_selection_line",!this.mode).attr("d",$r()(this.coords))}dragStart(t){let e=t.sourceEvent.offsetX,n=t.sourceEvent.offsetY;this.startPoint=[e,n],this.interationRect.append("path").attr("id","lasso"+this.randomString)}dragMove(t){const e=[t.sourceEvent.offsetX,t.sourceEvent.offsetY];this.coords=[this.startPoint,[this.startPoint[0],e[1]],e,[e[0],this.startPoint[1]],this.startPoint],this.drawPath()}dragEnd(){let t=[];const e=this.xScale,n=this.yScale,i=this.x_value,r=this.y_value,o=this.x_translate,s=this.y_translate,a=this.coords;br(".selected").each((e=>{t.push(e)})),this.selectables.classed("selected",(l=>{let u=[e(l[i])+o,n(l[r])+s];if(this.mode){if(ro(u,a)||t.find((t=>t===l)))return!0}else if(!ro(u,a)&&t.find((t=>t===l)))return!0})),Ai("#lasso"+this.randomString).remove(),this.callUpdateSelected()}drag=ji().on("start",this.dragStart.bind(this)).on("drag",this.dragMove.bind(this)).on("end",this.dragEnd.bind(this))}const so=["svg",to,[["path",{d:"M12.586 12.586 19 19"}],["path",{d:"M3.688 3.037a.497.497 0 0 0-.651.651l6.5 15.999a.501.501 0 0 0 .947-.062l1.569-6.083a2 2 0 0 1 1.448-1.479l6.124-1.579a.5.5 0 0 0 .063-.947z"}]]];class ao extends io{createButton(){return super.createButton(so)}selectionClickEffect(t){this.isSelected&&t.classed("selected",!t.classed("selected"))}}const lo=["svg",to,[["path",{d:"M18 6 6 18"}],["path",{d:"m6 6 12 12"}]]];class uo extends io{constructor(t,e){super(),this.selectables=t,this.callUpdateSelected=e}on_click(){this.selectables.classed("selected",!1),this.callUpdateSelected()}createButton(){return super.createButton(lo)}select(){}unselect(){}}const co=["svg",to,[["path",{d:"M7 22a5 5 0 0 1-2-4"}],["path",{d:"M3.3 14A6.8 6.8 0 0 1 2 10c0-4.4 4.5-8 10-8s10 3.6 10 8-4.5 8-10 8a12 12 0 0 1-5-1"}],["path",{d:"M5 18a2 2 0 1 0 0-4 2 2 0 0 0 0 4z"}]]];function ho(t,e){for(var n=t[0],i=t[1],r=!1,o=0,s=e.length-1;o<e.length;s=o++){var a=e[o][0],l=e[o][1],u=e[s][0],c=e[s][1];l>i!=c>i&&n<(u-a)*(i-l)/(c-l)+a&&(r=!r)}return r}class fo extends io{coords=[];randomString=Math.floor(Math.random()*Date.now()*1e4).toString(36);constructor(t,e,n,i,r,o,s,a,l,u){super(u),this.xScale=t,this.yScale=e,this.x_value=n,this.y_value=i,this.x_translate=r,this.y_translate=o,this.selectables=s,this.callUpdateSelected=a,this.interationRect=l,l.call(this.drag)}createButton(){return super.createButton(co)}updateScales(t,e){this.xScale=t,this.yScale=e}select(){super.select(),this.mode=!0,this.button.classList.add("mode_positive"),this.button.classList.remove("mode_negative"),this.interationRect.call(this.drag)}unselect(){super.unselect(),this.interationRect.on(".drag",null)}on_click(){this.isSelected&&this.changeMode(),super.on_click()}changeMode(){this.mode=!this.mode,this.mode?(this.button.classList.add("mode_positive"),this.button.classList.remove("mode_negative")):(this.button.classList.add("mode_negative"),this.button.classList.remove("mode_positive"))}drawPath(){Ai("#lasso"+this.randomString).classed("selection_line",this.mode).classed("negative_selection_line",!this.mode).attr("d",$r()(this.coords))}dragStart(t){this.coords=[];const e=[t.sourceEvent.offsetX,t.sourceEvent.offsetY];this.coords.push(e),this.coords.push(e),this.interationRect.append("path").attr("id","lasso"+this.randomString)}dragMove(t){const e=[t.sourceEvent.offsetX,t.sourceEvent.offsetY],n=this.coords.pop();this.coords.push(e),this.coords.push(n),this.drawPath()}dragEnd(){let t=[];const e=this.xScale,n=this.yScale,i=this.x_value,r=this.y_value,o=this.x_translate,s=this.y_translate,a=this.coords;br(".selected").each((e=>{t.push(e)})),this.selectables.classed("selected",(l=>{let u=[e(l[i])+o,n(l[r])+s];if(this.mode){if(ho(u,a)||t.find((t=>t===l)))return!0}else if(!ho(u,a)&&t.find((t=>t===l)))return!0})),Ai("#lasso"+this.randomString).remove(),this.callUpdateSelected()}drag=ji().on("start",this.dragStart.bind(this)).on("drag",this.dragMove.bind(this)).on("end",this.dragEnd.bind(this))}function po(t,e){return t.reduce((function(t,n){return{...t,[n[e]]:[...t[n[e]]??[],n]}}),{})}class mo{constructor(t){this.card=document.createElement("div"),this.card.style.display="none",this.card.classList.add("information_card"),this.cardBody=document.createElement("div"),this.card.appendChild(this.cardBody),t.appendChild(this.card)}showText(t,e,n){this.cardBody.innerHTML=t,this.card.style.display="block",this.timeout&&clearTimeout(this.timeout),this.timeout=setTimeout((()=>{this.card.style.visibility="visible",this.card.style.left=e+5-this.card.clientWidth/2+"px",this.card.style.top=n<80?n+20+"px":n-40-this.card.clientHeight/2+"px"}),10)}hide(){this.timeout&&clearTimeout(this.timeout),this.timeout=setTimeout((()=>{this.cardBody.innerHTML="",this.card.style.display="none",this.card.style.visibility="hidden"}),10)}}class go{static SIDE_BAR_WIDTH=32;constructor(t,...e){this.buttons=e,this.sideBar=document.createElement("div"),this.sideBar.style.width=go.SIDE_BAR_WIDTH+"px",this.sideBar.className="side_bar",this.sideBar.setAttribute("display","flex"),this.sideBar.setAttribute("flex-direction","column"),this.sideBar.setAttribute("justify-content","flex-start"),t.appendChild(this.sideBar);for(let t of e){const e=t.createButton();t.addClickNotification(this.notifyOtherButtons.bind(this)),this.sideBar.appendChild(e)}}notifyOtherButtons(t){for(let e of this.buttons)e!=t&&e.notified()}}class vo extends Wr{plot(t,e,n,i,r,o,s,a,l,u){t=function(t,e,n,i){function r(t){const r=t.reduce((function(t,r){if(!t[r[e]]){const o={};return o[e]=r[e],o[n]=r[n],i&&(o[i]=r[i]),o.count=1,t[r[e]]=o,t}return t[r[e]][n]+=r[n],t[r[e]].count+=1,t}),{}),o=Object.keys(r).map((function(t){const e=r[t],i={};return i[n]=e[n]/e.count,{...e,...i}}));return o.sort((a=1,"-"===(s=e)[0]&&(a=-1,s=s.substr(1)),function(t,e){return(t[s]<e[s]?-1:t[s]>e[s]?1:0)*a})),o;var s,a}if(!i)return r(t);let o=po(t,i),s=[];return Object.values(o).forEach((function(t,e){const n=r(t);s=s.concat(n)})),s}(t,e,[n],i);const c=new mo(this.element);u||(o-=go.SIDE_BAR_WIDTH);for(let e=0;e<t.length;e++)t[e].id=e;Math.floor(Math.random()*Date.now()*1e4).toString(36);var h=Fr().scaleExtent([1,50]).extent([[0,0],[o,s]]).translateExtent([[0,0],[o,s]]).on("zoom",(function(t){var i=t.transform.rescaleX(m),r=t.transform.rescaleY(v);l||(M.call(et(i)),A.call(nt(r))),u||k.updateScales(i,r),f.selectAll(".line-path").attr("d",$r().x((t=>i(t[e]))).y((t=>r(t[n])))),f.selectAll(".line-dot").attr("cx",(function(t){return i(t[e])})).attr("cy",(function(t){return r(t[n])}))}));this.init(o,s,a);const d=this.svg,f=this.gGrid;this.svg.call(h);const p=x(t,(function(t){return t[e]})),m=this.getXLinearScale(p,o,a),g=x(t,(function(t){return t[n]})),v=this.getYLinearScale(g,s,a),y=qi(_r);let _;function b(t,i){f.append("path").attr("class","line-path").datum(t).attr("fill","none").attr("stroke",y(i)).attr("stroke-width",2).attr("d",$r().x((t=>m(t[e]))).y((t=>v(t[n]))))}if(i){const e=po(t,i);Object.keys(e).forEach((function(t,n){b(e[t],t)}))}else b(t);const w=f.selectAll(".line-dot").data(t).enter().append("circle");let M,A,k;function S(){r&&r(f.selectAll(".line-dot.selected").data())}if(w.attr("class","line-dot").attr("r",3).attr("cx",(function(t){return m(t[e])})).attr("cy",(function(t){return v(t[n])})).style("fill",(function(t){return y(t[i])})).style("opacity",.2).on("mouseover",(function(t,i){Ai(this).style("opacity",1).attr("r",5);const r="x: "+Math.round(100*i[e])/100+"&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;y: "+Math.round(100*i[n])/100;c.showText(r,t.offsetX,t.offsetY)})).on("mouseout",(function(){Ai(this).style("opacity",.2).attr("r",3),c.hide()})).on("click",(function(t,i){Math.round(10*i[e]),Math.round(10*i[n]),_&&(_.selectionClickEffect(Ai(this)),S())})),l||([M,A]=this.plotAxes(f,m,v,e,n)),i){const t=f.selectAll(".legend").data(y.domain()).enter().append("g").attr("class","legend").attr("transform",(function(t,e){return"translate(0,"+20*e+")"}));t.append("rect").attr("x",o-a.left-a.right-18).attr("width",18).attr("height",18).style("fill",y),t.append("text").attr("x",o-a.left-a.right-24).attr("y",9).attr("dy",".35em").style("text-anchor","end").text((function(t){return t}))}function E(){d.on("mousedown.zoom",null)}if(!u){_=new ao(!0),_.addWhenSelectedCallback((function(){d.call(h)}));let t=new oo(m,v,e,n,a.left,a.top,w,S,d);t.addWhenSelectedCallback(E),k=new fo(m,v,e,n,a.left,a.top,w,S,d),k.addWhenSelectedCallback(E);let i=new uo(w,S);new go(this.element,_,t,k,i)}}replot(t,e,n,i,r,o,s,a,l,u){this.clear(),this.plot(t,e,n,i,r,o,s,a,l,u)}}class yo extends Wr{histList;getXDomain(t,e){let n=[];for(const i of e){const e=x(t,(function(t){return t[i]}));n=n.concat(e)}return x(n)}plot(t,e,n,i,r,o){Ai(this.element).selectAll("*").remove();const s=e.length,a=i/s;this.init(n,i,r),this.svg;const l=this.gGrid,u=this.getXDomain(t,e),c=this.getXLinearScale(u,n,r),h=this.getYBandScale(e,i,r,[.2]);o||this.plotAxes(l,c,h),this.histList=[];for(let o=0;o<s;o++){const u=e[o],h=new Zr(this.element);this.histList.push(h);const d=structuredClone(r);d.bottom=r.bottom+o*a,d.top=r.top+(s-o-1)*a;const f=l.append("g").attr("transform","translate(0,"+(d.top-r.top)+")");h.plot(t,u,n,i,d,!0,f,c)}}}class _o extends Wr{plot(t,e,n,i,r,o,s,a,l,u){const c=new mo(this.element);u||(o-=go.SIDE_BAR_WIDTH);for(let e=0;e<t.length;e++)t[e].id=e;const h=Math.floor(Math.random()*Date.now()*1e4).toString(36);var d=Fr().scaleExtent([1,50]).extent([[0,0],[o,s]]).translateExtent([[0,0],[o,s]]).on("zoom",(function(t){var i=t.transform.rescaleX(g),r=t.transform.rescaleY(y);l||(M.call(et(i)),A.call(nt(r))),u||k.updateScales(i,r),p.selectAll(".dot").attr("cx",(function(t){return i(t[e])})).attr("cy",(function(t){return r(t[n])}))}));this.init(o,s,a);const f=this.svg,p=this.gGrid;this.svg.call(d);const m=x(t,(function(t){return t[e]})),g=this.getXLinearScale(m,o,a),v=x(t,(function(t){return t[n]})),y=this.getYLinearScale(v,s,a),_=qi(_r);let b;const w=p.selectAll(".dot").data(t).enter().append("circle");let M,A,k;function S(){r&&r(p.selectAll(".dot.selected").data())}if(w.attr("id",(function(t,e){return"dot-"+h+t.id})).attr("class","dot").attr("r",5).attr("cx",(function(t){return g(t[e])})).attr("cy",(function(t){return y(t[n])})).style("fill",(function(t){return _(t[i])})).style("opacity",.5).on("mouseover",(function(t,i){Ai(this).style("opacity",1);const r="x: "+Math.round(100*i[e])/100+"&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;y: "+Math.round(100*i[n])/100;c.showText(r,t.offsetX,t.offsetY)})).on("mouseout",(function(){Ai(this).style("opacity",.5),c.hide()})).on("click",(function(t,i){Math.round(10*i[e]),Math.round(10*i[n]),b&&(b.selectionClickEffect(Ai(this)),S())})),l||([M,A]=this.plotAxes(p,g,y,e,n)),i){const t=p.selectAll(".legend").data(_.domain()).enter().append("g").attr("class","legend").attr("transform",(function(t,e){return"translate(0,"+20*e+")"}));t.append("rect").attr("x",o-a.left-a.right-18).attr("width",18).attr("height",18).style("fill",_),t.append("text").attr("x",o-a.left-a.right-24).attr("y",9).attr("dy",".35em").style("text-anchor","end").text((function(t){return t}))}function E(){f.on("mousedown.zoom",null)}if(!u){b=new ao(!0),b.addWhenSelectedCallback((function(){f.call(d)}));let t=new oo(g,y,e,n,a.left,a.top,w,S,f);t.addWhenSelectedCallback(E),k=new fo(g,y,e,n,a.left,a.top,w,S,f),k.addWhenSelectedCallback(E);let i=new uo(w,S);new go(this.element,b,t,k,i)}}replot(t,e,n,i,r,o,s,a,l,u){this.clear(),this.plot(t,e,n,i,r,o,s,a,l,u)}plotLines(t){let e=this.xScale,n=this.yScale;this.gGrid.selectAll("path.reference_line").data(Object.values(t)).join("path").attr("class","reference_line").attr("stroke",(t=>t.color)).attr("stroke-dasharray",(t=>{if(t.dashed)return"2,2"})).transition().attr("d",(function(t){return"horizontal"===t.direction?$r()([[e.range()[0],n(t.position)],[e.range()[1],n(t.position)]]):$r()([[e(t.position),n.range()[0]],[e(t.position),n.range()[1]]])}))}}const bo="#33AFFF",wo="#FF335B";function xo(t,e,n,i,r){const o=i(t),s=r(n)+r.bandwidth()/2,a=i(e)-i(0);let l=10;const u=r.bandwidth()/2;let c;return a<0&&(l=-l),c=Math.abs(a)<Math.abs(l)?[{x:o,y:s+u},{x:o+a,y:s},{x:o,y:s-u}]:[{x:o,y:s+u},{x:o+a-l,y:s+u},{x:o+a,y:s},{x:o+a-l,y:s-u},{x:o,y:s-u}],c}class Mo extends Wr{plot(t,e,n,i,r,o,s,a){this.baseValue=i,t.sort(function(t){let e=1;e=-1;var n=1;return"-"===t[0]&&(n=-1,t=t.substr(1)),function(i,r){return(Math.abs(i[t])<Math.abs(r[t])?e:Math.abs(i[t])>Math.abs(r[t])?-1*e:0)*n}}(e)),this.init(r,o,s);const l=this.gGrid,u=function(t,e,n){let i=n,r=n,o=n;t.forEach((t=>{o+=t[e],i>o&&(i=o),r<o&&(r=o)}));const s=r-i;return i-=.05*s,r+=.05*s,[i,r]}(t,e,i),c=this.getXLinearScale(u,r,s),h=t.map((function(t){return t[n]})),d=this.getYBandScale(h,o,s,[.2]);a||this.plotAxes(l,c,d,e,n);let f=i;l.selectAll().data(t).enter().append("polygon").attr("points",(function(t){const i=f;return f+=t[e],[xo(i,t[e],t[n],c,d)].map((function(t){return t.map((t=>[t.x,t.y].join(","))).join(" ")}))})).attr("fill",(t=>t[e]-0>=0?wo:bo)),f=i,l.selectAll().data(t).enter().append("path").attr("stroke","grey").attr("stroke-dasharray","2,2").attr("d",(function(t){return f+=t[e],$r()([[c(f),d(t[n])-d.bandwidth()/4],[c(f),d(t[n])+d.bandwidth()]])}));f=i,l.selectAll().data(t).enter().append("g").attr("width",50).attr("height",d.bandwidth()).attr("transform",(function(t){const i=f;let r;return f+=t[e],r=Math.abs(c(t[e])-c(0))>50?(c(f)+c(i))/2-25:t[e]>=0?c(f):c(f)-50,"translate("+r+", "+d(t[n])+")"})).append("text").attr("x",25).attr("y",d.bandwidth()/2).attr("dy",1).attr("dominant-baseline","middle").attr("text-anchor","middle").attr("fill",(function(t){return Math.abs(c(t[e])-c(0))>50?"white":t[e]>=0?wo:bo})).text((function(t){let n=""+Math.round(100*t[e])/100;return t[e]>=0&&(n="+"+n),n}))}replot(t,e,n,i,r,o,s,a){this.clear(),this.plot(t,e,n,i,r,o,s,a)}}class Ao extends b{defaults(){return{...super.defaults(),_model_name:Ao.model_name,_view_name:Ao.view_name,dataRecords:[],direction:String,x:String,y:String,hue:String,direction:Boolean,elementId:String}}static model_name="BarPlotModel";static view_name="BarPlotView"}class ko extends w{render(){this.plotAfterInterval(),this.model.on("change:dataRecords",(()=>this.plotAfterInterval()),this),this.model.on("change:x",(()=>this.plotAfterInterval()),this),this.model.on("change:y",(()=>this.plotAfterInterval()),this),this.model.on("change:hue",(()=>this.plotAfterInterval()),this),this.model.on("change:direction",(()=>this.plotAfterInterval()),this),window.addEventListener("resize",(()=>this.plotAfterInterval()))}plot(){this.barplot||(this.barplot=new Kr(this.getElement())),this.setSizes();const t=this.model.get("dataRecords"),e=this.model.get("x"),n=this.model.get("y"),i=this.model.get("hue"),r=this.model.get("direction");this.barplot.replot(t,e,n,i,r,this.width,this.height,this.margin,!1)}}class So extends b{defaults(){return{...super.defaults(),_model_name:So.model_name,_view_name:So.view_name,dataRecords:[],baseValue:Number,elementId:String}}static model_name="DecisionPlotModel";static view_name="DecisionPlotView"}class Eo extends w{render(){this.plotAfterInterval(),this.model.on("change:dataRecords",(()=>this.plotAfterInterval()),this),this.model.on("change:baseValue",(()=>this.plotAfterInterval()),this),window.addEventListener("resize",(()=>this.plotAfterInterval()))}plot(){this.decisionPlot||(this.decisionPlot=new Qr(this.getElement())),this.setSizes();let t=this.model.get("dataRecords"),e=this.model.get("baseValue");this.decisionPlot.replot(t,"values","feature_names",e,this.width,this.height,{top:20,right:20,bottom:30,left:80},!1)}}class Lo extends b{defaults(){return{...super.defaults(),_model_name:Lo.model_name,_view_name:Lo.view_name,dataRecords:[],x:String,elementId:String}}static model_name="HistogramPlotModel";static view_name="HistogramPlotView"}class Io extends w{render(){this.plotAfterInterval(),this.model.on("change:dataRecords",(()=>this.plotAfterInterval()),this),this.model.on("change:x",(()=>this.plotAfterInterval()),this),window.addEventListener("resize",(()=>this.plotAfterInterval()))}plot(){this.histogramplot||(this.histogramplot=new Zr(this.getElement())),this.setSizes();let t=this.model.get("dataRecords"),e=this.model.get("x");this.histogramplot.replot(t,e,this.width,this.height,this.margin,!1)}}class To extends b{defaults(){return{...super.defaults(),_model_name:To.model_name,_view_name:To.view_name,dataRecords:[],x:String,y:String,hue:String,elementId:String,selectedValuesRecords:[]}}static model_name="LinearPlotModel";static view_name="LinearPlotView"}class No extends w{render(){this.plotAfterInterval(),this.model.on("change:dataRecords",(()=>this.plotAfterInterval()),this),this.model.on("change:x",(()=>this.plotAfterInterval()),this),this.model.on("change:y",(()=>this.plotAfterInterval()),this),this.model.on("change:hue",(()=>this.plotAfterInterval()),this),window.addEventListener("resize",(()=>this.plotAfterInterval()))}plot(){this.linearplot||(this.linearplot=new vo(this.getElement())),this.setSizes();let t=this.model.get("dataRecords"),e=this.model.get("x"),n=this.model.get("y"),i=this.model.get("hue");this.linearplot.replot(t,e,n,i,this.setSelectedValues.bind(this),this.width,this.height,this.margin,!1,!1)}setSelectedValues(t){this.model.set({selectedValuesRecords:t}),this.model.save_changes()}}class $o extends b{defaults(){return{...super.defaults(),_model_name:$o.model_name,_view_name:$o.view_name,dataRecords:[],xAxes:String,elementId:String}}static model_name="RidgelinePlotModel";static view_name="RidgelinePlotView"}class Co extends w{render(){this.plotAfterInterval(),this.model.on("change:dataRecords",(()=>this.plotAfterInterval()),this),this.model.on("change:x",(()=>this.plotAfterInterval()),this),window.addEventListener("resize",(()=>this.plotAfterInterval()))}plot(){this.ridgelineplot||(this.ridgelineplot=new yo(this.getElement())),this.setSizes();let t=this.model.get("dataRecords"),e=this.model.get("xAxes");this.ridgelineplot.plot(t,e,this.width,this.height,this.margin,!1)}}class zo extends b{defaults(){return{...super.defaults(),_model_name:zo.model_name,_view_name:zo.view_name,dataRecords:[],x:String,y:String,hue:String,elementId:String,selectedValuesRecords:[],lines:{}}}static model_name="ScatterPlotModel";static view_name="ScatterPlotView"}class Vo extends w{render(){this.plotAfterInterval(),this.model.on("change:dataRecords",(()=>this.plotAfterInterval()),this),this.model.on("change:x",(()=>this.plotAfterInterval()),this),this.model.on("change:y",(()=>this.plotAfterInterval()),this),this.model.on("change:hue",(()=>this.plotAfterInterval()),this),this.model.on("change:lines",(()=>this.setLines()),this),window.addEventListener("resize",(()=>this.plotAfterInterval()))}plot(){this.scatterplot||(this.scatterplot=new _o(this.getElement())),this.setSizes();let t=this.model.get("dataRecords"),e=this.model.get("x"),n=this.model.get("y"),i=this.model.get("hue");this.scatterplot.replot(t,e,n,i,this.setSelectedValues.bind(this),this.width,this.height,this.margin,!1,!1),this.setLines()}setSelectedValues(t){this.model.set({selectedValuesRecords:t}),this.model.save_changes()}setLines(){let t=this.model.get("lines");this.scatterplot.plotLines(t)}}class Ro extends b{defaults(){return{...super.defaults(),_model_name:Ro.model_name,_view_name:Ro.view_name,dataRecords:[],x:String,y:String,baseValue:Number,elementId:String}}static model_name="WaterfallPlotModel";static view_name="WaterfallPlotView"}class Po extends w{render(){this.plotAfterInterval(),this.model.on("change:dataRecords",(()=>this.plotAfterInterval()),this),this.model.on("change:x",(()=>this.plotAfterInterval()),this),this.model.on("change:y",(()=>this.plotAfterInterval()),this),this.model.on("change:baseValue",(()=>this.plotAfterInterval()),this),window.addEventListener("resize",(()=>this.plotAfterInterval()))}plot(){this.waterfall||(this.waterfall=new Mo(this.getElement())),this.setSizes();let t=this.model.get("dataRecords"),e=this.model.get("x"),n=this.model.get("y"),i=this.model.get("baseValue");this.waterfall.replot(t,e,n,i,this.width,this.height,{top:20,right:20,bottom:30,left:80},!1)}}class jo extends b{defaults(){return{...super.defaults(),_model_name:jo.model_name,_view_name:jo.view_name,matrix:[],grid_areas:[],grid_template_areas:String,style:String}}static model_name="MatrixLayoutModel";static view_name="MatrixLayoutView"}class Do extends w{render(){this.value_changed()}value_changed(){const t=this.model.get("matrix"),e=this.model.get("grid_areas"),n=this.model.get("grid_template_areas");let i=this.model.get("style");i||(i="basic");const r=document.createElement("div");r.classList.add(i),r.style.display="grid",r.style.gridTemplateAreas=n,r.style.gridTemplateRows="repeat("+t.length+", 180px)",r.style.gridTemplateColumns="repeat("+t[0].length+", 1fr)",r.style.width="100%",e.forEach((t=>{const e=document.createElement("div");e.setAttribute("id",t),e.style.gridArea=t,e.classList.add("dashboard-div"),r.appendChild(e)})),this.el.appendChild(r)}}class Bo extends b{defaults(){return{...super.defaults(),_model_name:Bo.model_name,_view_name:Bo.view_name,value:String,format:"jpg",width:Number,height:Number}}static model_name="ImageModel";static view_name="ImageView"}class Oo extends w{remove(){this.src&&URL.revokeObjectURL(this.src),super.remove()}render(){this.plotAfterInterval(),this.model.on("change:value",(()=>this.plotAfterInterval()),this),this.model.on("change:width",(()=>this.plotAfterInterval()),this),this.model.on("change:height",(()=>this.plotAfterInterval()),this),window.addEventListener("resize",(()=>this.plotAfterInterval()))}plot(){this.el.innerHTML="";let t=this.model.get("value"),e=this.model.get("format"),n=this.model.get("width"),i=this.model.get("height");this.setSizes(),n&&(this.width=n),i&&(this.height=i);const r=document.createElement("div"),o=document.createElement("img"),s=`image/${e}`,a=new Blob([t],{type:s}),l=URL.createObjectURL(a),u=this.src;this.src=l,u&&URL.revokeObjectURL(u),o.setAttribute("src",this.src),o.setAttribute("type",s),o.style.maxWidth="100%",o.style.maxHeight="100%",o.style.margin="auto",o.style.display="block",r.style.width=this.width+"px",r.style.height=this.height+"px",r.appendChild(o),this.getElement().appendChild(r)}}class Xo extends b{defaults(){return{...super.defaults(),_model_name:Xo.model_name,_view_name:Xo.view_name,value:new DataView(new ArrayBuffer),format:"mp4",width:Number,height:Number,currentTime:Number,controls:!0,loop:!0,_play:Boolean,_pause:Boolean,_duration:Number,_seekTo:Number}}static serializers={...b.serializers,value:{serialize:t=>new DataView(t.buffer.slice(0))}};static model_name="VideoModel";static view_name="VideoView"}class Ho extends w{remove(){this.src&&URL.revokeObjectURL(this.src),super.remove()}play(){this.video&&this.video.play()}pause(){this.video&&this.video.pause()}seekTo(){if(!this.video)return;const t=this.model.get("_seekTo");this.video.currentTime=t}setCurrentTime(){const t=this.video.currentTime;this.model.set({_currentTime:t}),this.model.save_changes()}setControls(){this.video&&(this.model.get("controls")?this.video.setAttribute("controls",""):this.video.removeAttribute("controls"))}setLoop(){if(!this.video)return;let t=this.model.get("loop");this.video.loop=t}setMuted(){if(!this.video)return;let t=this.model.get("muted");this.video.muted=t}setVolume(){if(!this.video)return;let t=this.model.get("volume");this.video.volume=t}render(){this.plotAfterInterval(),this.model.on("change:value",(()=>this.plotAfterInterval()),this),this.model.on("change:width",(()=>this.plotAfterInterval()),this),this.model.on("change:height",(()=>this.plotAfterInterval()),this),this.model.on("change:_seeked",(()=>this.seekTo()),this),this.model.on("change:controls",(()=>this.setControls()),this),this.model.on("change:loop",(()=>this.setLoop()),this),this.model.on("change:muted",(()=>this.setMuted()),this),this.model.on("change:volume",(()=>this.setVolume()),this),this.model.on("change:_play",(()=>this.play()),this),this.model.on("change:_pause",(()=>this.pause()),this),window.addEventListener("resize",(()=>this.plotAfterInterval()))}plot(){this.el.innerHTML="";let t=this.model.get("value"),e=this.model.get("format"),n=this.model.get("width"),i=this.model.get("height"),r=this.model.get("controls");this.setSizes(),n&&(this.width=n),i&&(this.height=i),this.video=document.createElement("video");const o=document.createElement("source"),s=`video/${e}`,a=new Blob([t],{type:s}),l=URL.createObjectURL(a),u=this.src;this.src=l,u&&URL.revokeObjectURL(u),o.setAttribute("src",this.src),o.setAttribute("type",s),this.video.appendChild(o),r&&this.video.setAttribute("controls",""),this.setLoop(),this.setMuted(),this.setVolume(),this.video.style.margin="auto",this.video.style.display="block",this.video.style.width=this.width+"px",this.video.style.height=this.height+"px",this.video.addEventListener("timeupdate",this.setCurrentTime.bind(this)),this.getElement().appendChild(this.video),setTimeout((()=>{this.model.set({_duration:this.video.duration}),this.model.save_changes()}),50)}}class qo extends b{defaults(){return{...super.defaults(),value:String,placeholder:String,description:String,disabled:!1,elementId:String}}}class Yo extends w{setText(){}setPlaceholder(){const t=this.model.get("placeholder");this.text.setAttribute("placeholder",t)}setDescription(){const t=this.model.get("description");if(this.getElement().innerHTML="",t){const e=document.createElement("label");e.setAttribute("title",t),e.innerHTML=t+": ",e.style.verticalAlign="top",this.getElement().appendChild(e)}this.getElement().appendChild(this.text)}setDisabled(){this.model.get("disabled")?this.text.setAttribute("disabled",""):this.text.removeAttribute("disabled")}render(){this.plotAfterInterval(),this.model.on("change:value",(()=>this.setText()),this),this.model.on("change:placeholder",(()=>this.setPlaceholder()),this),this.model.on("change:description",(()=>this.setDescription()),this),this.model.on("change:disabled",(()=>this.setDisabled()),this),window.addEventListener("resize",(()=>this.plotAfterInterval()))}plot(){this.setText(),this.setPlaceholder(),this.setDescription(),this.setDisabled()}}class Uo extends b{defaults(){return{...super.defaults(),_model_name:Uo.model_name,_view_name:Uo.view_name,description:String,disabled:!1,_clicked:Boolean,elementId:String}}static model_name="ButtonModel";static view_name="ButtonView"}class Fo extends w{setDescription(){const t=this.model.get("description");this.button.setAttribute("title",t),this.button.innerHTML=t}setDisabled(){this.model.get("disabled")?this.button.setAttribute("disabled",""):this.button.removeAttribute("disabled")}setClicked(){const t=this.model.get("_clicked");this.model.set({_clicked:!t}),this.model.save_changes()}render(){this.plotAfterInterval(),this.model.on("change:description",(()=>this.setDescription()),this),this.model.on("change:disabled",(()=>this.setDisabled()),this),window.addEventListener("resize",(()=>this.plotAfterInterval()))}plot(){this.button=document.createElement("button"),this.button.addEventListener("click",this.setClicked.bind(this)),this.setDescription(),this.setDisabled(),this.getElement().appendChild(this.button)}}class Wo extends b{defaults(){return{...super.defaults(),_model_name:Wo.model_name,_view_name:Wo.view_name,dataRecords:[],variable:String,description:String,options:[],value:String,disabled:!1,elementId:String}}static model_name="DropdownModel";static view_name="DropdownView"}class Go extends w{setDescription(){const t=this.model.get("description");this.label.innerHTML=t+": "}setDisabled(){this.model.get("disabled")?this.select.setAttribute("disabled",""):this.select.removeAttribute("disabled")}setOptions(){const t=this.model.get("dataRecords"),e=this.model.get("variable");let n=this.model.get("options");0===n.length&&t.length>0&&(n=[...new Set(t.map((t=>t[e])))].sort()),this.select.innerHTML="";for(const t of n){const e=document.createElement("option");e.setAttribute("value",t),e.innerHTML=t,this.select.appendChild(e)}}setValue(){this.model.set({value:this.select.value}),this.model.save_changes()}render(){this.plotAfterInterval(),this.model.on("change:dataRecords",(()=>this.plotAfterInterval()),this),this.model.on("change:variable",(()=>this.plotAfterInterval()),this),this.model.on("change:description",(()=>this.setDescription()),this),this.model.on("change:options",(()=>this.setOptions()),this),this.model.on("change:disabled",(()=>this.setDisabled()),this),window.addEventListener("resize",(()=>this.plotAfterInterval()))}plot(){this.getElement().innerHTML="";const t=Math.floor(Math.random()*Date.now()*1e4).toString(36);this.dropdown=document.createElement("div"),this.label=document.createElement("label"),this.label.setAttribute("for",t),this.setDescription(),this.select=document.createElement("select"),this.select.setAttribute("id",t),this.select.addEventListener("change",this.setValue.bind(this)),this.setDisabled(),this.dropdown.appendChild(this.label),this.dropdown.appendChild(this.select),this.setOptions();const e=this.model.get("value");e&&(this.select.value=e),this.getElement().appendChild(this.dropdown)}}class Ko extends qo{defaults(){return{...super.defaults(),_model_name:Ko.model_name,_view_name:Ko.view_name}}static model_name="InputModel";static view_name="InputView"}class Jo extends Yo{setText(){const t=this.model.get("value");this.text.value=t}setValue(){const t=this.text.value;this.model.set({value:t}),this.model.save_changes()}plot(){this.text=document.createElement("input"),this.text.addEventListener("change",this.setValue.bind(this)),super.plot()}}class Qo extends b{defaults(){return{...super.defaults(),_model_name:Qo.model_name,_view_name:Qo.view_name,dataRecords:[],variable:String,step:Number,description:String,minValue:Number,maxValue:Number,elementId:String}}static model_name="RangeSliderModel";static view_name="RangeSliderView"}class Zo extends w{render(){this.plotAfterInterval(),this.model.on("change:dataRecords",(()=>this.plotAfterInterval()),this),this.model.on("change:variable",(()=>this.plotAfterInterval()),this),this.model.on("change:step",(()=>this.plotAfterInterval()),this),this.model.on("change:description",(()=>this.plotAfterInterval()),this),this.model.on("change:minValue",(()=>this.plotAfterInterval()),this),this.model.on("change:maxValue",(()=>this.plotAfterInterval()),this),window.addEventListener("resize",(()=>this.plotAfterInterval()))}plot(){const t=this.model.get("dataRecords");let e=this.model.get("variable"),n=this.model.get("step"),i=this.model.get("description"),r=this.model.get("elementId"),o=this.model.get("fromValue"),s=this.model.get("toValue"),a=this.model.get("minValue"),l=this.model.get("maxValue"),u=this.el;r&&(u=document.getElementById(r));const c=_;!function(t,e,n,i,r,o,s,a,l,u,c,h){const d=document.createElement("div");d.classList.add("range_outside_container"),d.style.margin=h.top+"px "+h.right+"px "+h.bottom+"px "+h.left+"px";const f=document.createElement("span");f.classList.add("range_description"),f.textContent=i,d.appendChild(f);const p=document.createElement("div");p.classList.add("range_inside_container"),d.appendChild(p);const m=document.createElement("span");m.classList.add("range_value"),d.appendChild(m);const g=document.createElement("div");g.classList.add("sliders_control"),p.appendChild(g);const v=document.createElement("input");v.classList.add("top_slider"),v.setAttribute("step",n),v.setAttribute("type","range"),g.appendChild(v);const y=document.createElement("input");function _(t,e){m.textContent=t+" - "+e,l(t,e)}y.setAttribute("step",n),y.setAttribute("type","range"),g.appendChild(y),!s&&t.length>0&&(s=X(t,(t=>t[e]))),!a&&t.length>0&&(a=O(t,(t=>t[e]))),v.setAttribute("min",s),v.setAttribute("max",a),y.setAttribute("min",s),y.setAttribute("max",a),v.value=r||s,y.value=o||a;const b=parseFloat(v.value),w=parseFloat(y.value),x=parseFloat(s),M=parseFloat(a);_(b,w),u(x,M),v.addEventListener("input",(()=>{const t=parseFloat(v.value),e=parseFloat(y.value);t>e&&(v.value=y.value),_(t,e)})),y.addEventListener("input",(()=>{const t=parseFloat(v.value),e=parseFloat(y.value);e<t&&(y.value=v.value),_(t,e)})),v.addEventListener("click",(()=>{v.classList.add("top_slider"),y.classList.remove("top_slider")})),y.addEventListener("click",(()=>{y.classList.add("top_slider"),v.classList.remove("top_slider")})),c.innerHTML="",c.appendChild(d)}(t,e,n,i,o,s,a,l,this.setFromTo.bind(this),this.setMinMax.bind(this),u,c)}setFromTo(t,e){this.model.set({fromValue:t}),this.model.set({toValue:e}),this.model.save_changes()}setMinMax(t,e){this.model.set({minValue:t}),this.model.set({maxValue:e}),this.model.save_changes()}}class ts extends qo{defaults(){return{...super.defaults(),_model_name:ts.model_name,_view_name:ts.view_name}}static model_name="TextAreaModel";static view_name="TextAreaView"}class es extends Yo{setText(){const t=this.model.get("value");this.text.value=t}setValue(){const t=this.text.value;this.model.set({value:t}),this.model.save_changes()}plot(){this.text=document.createElement("textarea"),this.text.addEventListener("change",this.setValue.bind(this)),super.plot()}}class ns extends qo{defaults(){return{...super.defaults(),_model_name:ns.model_name,_view_name:ns.view_name}}static model_name="TextModel";static view_name="TextView"}class is extends Yo{setText(){const t=this.model.get("value");this.text.innerHTML=t}plot(){this.text=document.createElement("div"),this.text.style.marginLeft="4px",this.getElement().style.display="flex",super.plot()}}})(),o})()));